'Script de mesures de performances pour Premiere CS5.5, CS6 et Edius 6.0x et 6.5x
'Bas sur une ide originale de Wm. C. Gehrke and Harm Millaard v26 for CS5.5 pour le test PPMB5
'
' Copyright  Olivier Gonnet  Avril 2013
' Voir la documentation et mode opratoire dans le fichier Test_Perfs.pdf
' Ce script ncessite les fichiers sources Test_Sources
' et pour Premiere un fichier projet Test_CSxx.prproj 
' ou pour Edius    un fichier projet Test_Ediusxx.ezp  

Option Explicit
Dim Debug : Debug = 0
' 0    = pas d'infos de dbug
' 1-6  = infos dbug  l'cran
' 1    = infos gnrales
' 2    = appels fonctions
' 3    = rpertoires traits
' 4    = dtail des fonctions
' 5    = dtail des fichiers
' 6    = dtail des paramtres
' 11-16 = idem : infos dbug cran + fichier Log
' 21-26 = idem, uniquement fichier log
' valeurs ngatives : idem sans lancement de l'application

Dim ForceOOo : ForceOOo = 1        ' = 1 permet de tester OpenOffice si prsent en mme temps qu'Excel 

Dim Maxclips1 : Maxclips1 = 100    ' Clips sur la piste Vido 1
Dim Maxclips2 : Maxclips2 = 10     ' Clips sur la piste Vido 2
Dim Maxtitles : Maxtitles = 10     ' Titres sur la piste Titres ou Vido 3

Dim Titre_suffix  : Titre_suffix = ""                                     'suffixe par dfaut de l'application (.prtl ou .etl) 
Dim Video_suffix  : Video_suffix = ".m2ts"
Dim Export_suffix : Export_suffix = ".MP4"

Dim WshShell, objShell, AppShell, oFs, oFolder, oF, oReg                  ' objets du  File system
Dim UserEnvVars, SystEnvVars, Uprof, SysDisk, D_Mode                      ' variables d'environnement
Dim DirPath, SrcPath, Presets, Path, Dir, SubDir, Rep                     ' noms de rpertoires
Dim Lau, Reg_Key, strKeyPath, keylist, subkey, Key_value, AppData         ' cls de la Base de Registre
Dim Prem_name, Prem_instal_def, CS_col, Prem_instal_dir 
Dim Prem_cache_Flag, Prem_cuda, Prem_acceler, Prem_Lexp, Prem_Prefs_Exp
Dim Prem55_key, CS5_key, CS5_col, Prem55_version, Prem55_instal, Prem55_dir, Prem55_name
Dim Prem55_exe, Prem55_rendu, Prem55_cache, Prem55_prefs, Prem55_presets, Prem55_seq
Dim Prem60_key, CS6_key, CS6_col, Prem60_version, Prem60_instal, Prem60_dir, Prem60_name
Dim Prem60_exe, Prem60_rendu, Prem60_cache, Prem60_prefs, Prem60_presets, Prem60_seq
Dim Edius60_key_32, Edius60_key_64, Edius60_version, Edius60_instal, Edius60_dir, Edius60_exe, Edius60_rendu, Edius60_cache, Edius60_prefs
Dim Edius65_key_32, Edius65_key_64, Edius65_version, Edius65_instal, Edius65_dir, Edius65_exe, Edius65_rendu, Edius65_cache, Edius65_prefs
Dim Edius_User, Edius_UserP, Edius_UserN, Edius_filekey, Edius_foldkey, Edius_Guiset
Dim InstallLocation, InstallKey, Prog_Dir, Prog_Exe, Prog_Ver, Prog_run, Version, Alt_ver, Exec_name  
Dim Projet, Projbak, Proj_Create, Proj_Test, Proj_suffix, Prev_Dir 
Dim File_Parms, Presets_Dir, Preset_Fileprefix, Preset_File
Dim Rendu, Rendu_prefix, Rendu_suffix
Dim DVD, Bluray, Avchd
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ' caractristiques des disques
Dim Texte, Titre, Msg, Boutons, Ret                                       ' Boites de dialogue et Messages
Dim defaultValue1, defaultValue2, Choix, Comment, Appli                   ' choix par dfaut
Dim Key, Keyname, KeyEnd, Vpos, Value, Vlen, Nval                         ' cls des fichiers paramtres
Dim Test_Create, FirstRun, Time1, Time2, Time3, Time4, Time5              ' Heures de rfrence
Dim Tsrc, Duree, Duree1, Duree2, Tinit, TRatio                            ' Dures des taches
dim FirstTime, DebTime, FinTime, ModFlag, AccesTime                       ' Dates d'accs
Dim Src_Test, Projet_Src, From,  Dest                                     ' Fichiers sources
Dim Prem_R_audio, Prem_R_video, SameasProj                                ' Fichiers de prvisualisation
Dim FirstFile, LastFile, Fname                                            ' noms fichiers traits
Dim Exp_Proj, ExpPath, ExpFile, Nbexp, Flong                              ' Fichiers export
Dim Cache_Dir, CacheFiles_Dir, Medias_cache                               ' Fichiers caches
Dim oLogDir, oLog, LogPath, LogFile , NotePad, RetNote                    ' Fichiers Logs
Dim Report_Proj, Report_File, XLpath, XLfile, XLurl, XLflag, XLtype       ' Fichiers rapports Excel
Dim objExcel, oSM, oDesk, oWB, oWS, oXL, oCursor, NF,NFS, oCell           ' objets Excel / Open Office
Dim XLtab () , args(0),  Sargs(0), Lastline                               ' tableau valeurs pour recap Excel (2eme dimension dynamique)
Dim GpuZ_key, GpuZ_instal_dir, GpuZ_prog, GpuZ_exe, GpuZ_ver, GpuZ_log    ' variables pour GPU-Z
Dim G_load_moy, G_load_max                                                ' Charge GPU
Dim SmartCtl_dir, SmartCtl_prog, SmartCtl_cmd, SmartCtl_Log               ' Recherche type des disques
Dim strProcessKill                                                        ' proccess  arreter

Dim Temp, Ftemp, Fparm                                                    ' Fichiers temporaires
Dim ErrMsg, DbgTxt, DbgSave, Reply                                        ' Messages d'erreur et de debug
Dim Files_Inc(), Ftab(34)                                                 ' Tableaux de suffixes Inclus, tableau proprits de fichier
ReDim Files_Inc(10) 

Dim Source_Inc(3)                                                         ' Suffixes accepts dans les sources
Source_Inc (0) = "m2t"
Source_Inc (1) = "prt"
Source_Inc (2) = "etl"
Source_Inc (3) = "mp3"

Dim Cache_Inc(3)                                                          ' Suffixes accepts dans les caches
Cache_Inc (0) = "cfa"
Cache_Inc (1) = "pek"
Cache_Inc (2) = "ewc"  
Cache_Inc (3) = "ese" 

Dim Rendu_Inc(3)                                                          ' Suffixes accepts dans les rendus                                          
Rendu_Inc (0) = "mpe"  
Rendu_Inc (1) = "mpg"  
Rendu_Inc (2) = "avi" 
Rendu_Inc (3) = "xmp" 

Dim Export_Inc(5)                                                         ' Suffixes accepts dans les exports    
Export_Inc (0) = "mp4"  
Export_Inc (1) = "m4v" 
Export_Inc (2) = "m2t"      
Export_Inc (3) = "mpg" 
Export_Inc (4) = "ac3"
Export_Inc (5) = "aac"

Dim OsType, System,  OsName, Cpu, Cpu_F, Cpu_Fm, Msize, Mfreq, Vcard, Vmem, Vproc ' caractristiques cnfiguration

Dim i, j, k, nb,  sr , index                                               ' variables d'indices
Dim quote : quote = """"
Dim force : force = true

'=================
' Generic MS Excel et Open Office VBA constants
'=================
' Excel horizontal / Vertical alignment constants
Const xlHAlignCenter = -4108
Const xlVAlignCenter = -4108
const xlHAlignLeft   = -4131

' OOo horizontal / Vertical alignment constants
Const VertJustifyCENTER    = 2
Const HoriJustifyCENTER    = 2
Const HoriJustifyLEFT      = 1

' Contantes de la base de registres
const HKEY_LOCAL_MACHINE = &H80000002
const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7
' ----------------------------------------------------------------------------------------------------------------
On Error Resume Next
Set objShell = WScript.CreateObject("WScript.Shell")
Set WshShell = CreateObject("WScript.Shell")
Set oFs = CreateObject("Scripting.FileSystemObject")
Set UserEnvVars = objShell.Environment("User")
Set SystEnvVars = objShell.Environment("System")

'  DirPath = WshShell.CurrentDirectory
 DirPath = oFS.GetParentFolderName (WScript.ScriptFullName)
If Right(DirPath,1) <> "\" Then DirPath = DirPath & "\"
 Set oFolder = oFs.GetFolder (DirPath)         
 Test_Create = oFolder.DateCreated                            '  Date de la premiere cration du rpertoire Test_Perfs (Unzip)
'
' --- On rexecute le script en mode administrateur pour contourner l'UAC
If WScript.Arguments.length =0 Then
      Set AppShell = CreateObject("Shell.Application")
      'Pass a bogus argument with leading blank space, say [ uac] 
      AppShell.ShellExecute "wscript.exe", Chr(34) & WScript.ScriptFullName & Chr(34) & " uac", "", "runas", 1
     If Err.Number <> 0 Then
      ' Le script se trouve probablement sur un disque rseau : pas accept par W8
      MsgBox "Copiez le rpertoire " &DirPath &" sur un disque local, et relancez le test"
      Set oFs = Nothing
      WScript.Quit()
     End If
Else

 WScript.Timeout=0
 Lau =  "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\FileSystem\NtfsDisableLastAccessUpdate"
 Prem_instal_def = "C:\Program Files (x86)\Adobe"
 Prem_instal_dir = "C:\Program Files\Adobe"

 CS5_key         = "HKLM\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{D57FC112-312E-4D70-860F-2DB8FB6858F0}\"
 CS5_Col         = "Adobe Creative Suite 5.5" ' Master Collection ou Production Premium
 Prem55_version  = "CS5.5"
 Prem55_name     = "Adobe Premiere Pro CS5.5"
 Prem55_key      = "HKLM\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{D57FC112-312E-4D70-860F-2DB8FB6858F0}\"
 Prem55_cache    = "HKEY_CURRENT_USER\Software\Adobe\Common CS5.5\Media Cache\"
 Prem55_prefs    = "Adobe\Premiere Pro\5.5\Adobe Premiere Pro Prefs"
 Prem55_seq      = "Adobe\Premiere Pro\5.5\Settings\Personnalis"
 Prem55_presets  = "Adobe\Common\AME\5.5\Presets"
 Prem55_instal   = "InstallLocation"
 Prem55_dir      = "\Adobe Premiere Pro CS5.5"
 Prem55_exe      = "\Adobe Premiere Pro.exe"
 Prem55_rendu    = "Adobe Premiere Pro Preview Files\"

 
 CS6_key         = "HKLM\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{E8AD3069-9EB7-4BA8-8BFE-83F4E69355C0}\"
 CS6_Col         = "Adobe Creative Suite 6"   ' Master Collection ou Production Premium
 Prem60_version  = "CS6"
 Prem60_name     = "Adobe Premiere Pro CS6"  
 Prem60_key      = "HKLM\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{7176B973-6011-43C1-AEBC-2D73FE7C6982}\"
 Prem60_cache    = "HKEY_CURRENT_USER\Software\Adobe\Common CS6\Media Cache\"
 Prem60_prefs    = "Adobe\Premiere Pro\6.0\Adobe Premiere Pro Prefs"
 Prem60_seq      = "Adobe\Premiere Pro\6.0\Settings\Personnalis"
 Prem60_presets  = "Adobe\Common\AME\6.0\Presets"
 Prem60_instal   = "InstallLocation"
 Prem60_dir      = "\Adobe Premiere Pro CS6"
 Prem60_exe      = "\Adobe Premiere Pro.exe"
 Prem60_rendu    = "Adobe Premiere Pro Preview Files\"

 Prem_cache_Flag = "<BE.Prefs.MediaCache.FilesSideBySide>"
 Prem_acceler    = "<BE.Prefs.AcceleratedRenderer.LastUsedDisplayName>"
 Prem_cuda       = "GPU Mercury Playback Engine"
 Prem_Lexp       = "<MZ.Prefs.Export.LastExportedPresetType>"
 Prem_Prefs_Exp  = "<MZ.Prefs.Export.Media.Path>"
 Prem_R_audio    = "<AudioPreviewLocation>"
 Prem_R_video    = "<VideoPreviewLocation>"
 SameasProj      = "SameAsProject"

 Edius60_version = "Edius60"
 Edius60_key_32  = "HKLM\SOFTWARE\Canopus\EDIUS\6.00\Installation\EDIUS\"
 Edius60_key_64  = "HKLM\SOFTWARE\Wow6432Node\Canopus\EDIUS\6.00\Installation\EDIUS\"
 Edius60_prefs   = "Canopus\EDIUS\6.00\"
 Edius60_instal  = "DestDir"
 Edius60_dir     = "\"
 Edius60_exe     = "EDIUS.exe"
 Edius60_rendu   = "rendered"

 Edius65_version = "Edius65"
 Edius65_key_32  = "HKLM\SOFTWARE\Grass Valley\EDIUS\7.00\Installation\EDIUS\"
 Edius65_key_64  = "HKLM\SOFTWARE\Wow6432Node\Grass Valley\EDIUS\7.00\Installation\EDIUS\"
 Edius65_prefs   = "Grass Valley\EDIUS\7.00\"
 Edius65_instal  = "DestDir"
 Edius65_dir     = "\"
 Edius65_exe     = "EDIUS.exe"
 Edius65_rendu   = "rendered"

 Edius_User      =  "User\User099" 
 Edius_UserP     = "<CurrentUserProfile>"
 Edius_UserN     = string (5, vbtab) &"<name>Test_Perfs_Edius</name>"
 Edius_filekey   = "<FileDialog>"
 Edius_foldkey   = "<Folder>"
 Edius_Guiset    = "CtsGuiSettings.esp"

DVD    = "DVD-"
Bluray = "Bluray-"
Avchd  = "H264-"

 GpuZ_Key        = "HKEY_CURRENT_USER\Software\techPowerUp\GPU-Z"
 GpuZ_exe        = "GPU-Z.exe"
 NotePad         = "notepad.exe"
 Cache_Dir       = ""
 Src_Test        = "Test_Sources\"
 Proj_Test       = "Test_Projets\"
 Presets         = "Test_Presets\"
 Report_Proj     = "Test_Reports\"
 Projet_Src      = "Projet_Src"
 Exp_Proj        = "Exports\"
 Preset_Fileprefix = "Test_Perfs_"
 Report_File     = "Test_Recap.xls"

 DbgSave = Debug
 '
 '--- Programme principal
  Set oFolder = oFs.GetFolder (DirPath) 

  AppData = WshShell.ExpandEnvironmentStrings("%APPDATA%")
  If Right(AppData,1) <> "\" Then AppData = AppData & "\"

  '--- Set prompt and title
  Msg = "Rpertoire de Travail =  " & DirPath &vbcrlf &vbcrlf 
  Msg = Msg &vbcrlf &"Choisir l'application de Montage  tester " &vbcrlf  &vbcrlf  & "CS5.5,  CS6,  Edius60,  Edius65" &vbcrlf
  Msg = Msg &vbcrlf &"et donner un commentaire explicite"  &vbcrlf &"(spars par une virgule)" 
  Titre = "Tests performances "

  defaultValue1 = Prem55_version 
  defaultValue2 = "Test sur disque montage unique" 

 '--- Display message, title, and default value.
  Choix = InputBox(Msg, Titre, defaultValue1 &"   , " &defaultValue2)
 '  If user has clicked OK, set Choix to defaultValue, CANCEL : abandon
     If Choix = "" Then 
      msgbox  " Script abandonn "
      WScript.Quit()
     Else
       sr = Split (Choix, ",", -1, 1)  
       Choix   = sr(0)
       Comment = sr(1)
     End If
      Comment = Ltrim(Comment)
      Choix = Lcase (RTrim(Choix))
      Appli = Ucase (Choix)
      ReDim XLtab (21,50)
      XLtab (1, 0) = Appli

 '--- Cration du fichier LOG

  LogPath = Dirpath & "Test_Logs\"
  If  Not oFs.FolderExists(LogPath)  Then  oLogDir =  oFs.CreateFolder(Logpath)
    Set oFolder = oFs.GetFolder (LogPath) 
    index= 0
    For Each oF In oFolder.files   
      Ftemp =  oF.Name
      Logfile = "Log_" &index
      i = InStr(1, Ftemp, "_", 0)
      j = InStr(i+1, Ftemp, "_", 0)
      k = CInt (Mid (Ftemp, i+1, j-i-1) )
      If k > index Then index = k
      DbgTxt = ("oldlog = " & Ftemp  &" i= " &i &" j= " &j &" k= " &k &" index = " & index)  : Call DbgMsg (DbgTxt, 6)
    Next
    index = index+1
   Logfile = "Log_" &index &"_" &Comment  &".txt"
  Set oLog = oFs.CreateTextFile(LogPath & Logfile,True,False)  
  XLtab (3, 1) = Logfile
  DbgTxt = " Rpertoire de Travail  :  "  &DirPath  : Call DbgMsg (DbgTxt, 3)
  DbgTxt =  ("Choix: " &Choix & " Comment: " &Comment)  :  Call DbgMsg (DbgTxt, 3)

 ' --- Determination de la configuration

   call Conf_Type 
   XLtab (4, 1) = System
   XLtab (5, 0) = Cpu
   XLtab (5, 1) = Msize &" MB  " &Mfreq &" Mhz"
   XLtab (6, 0) = "unknow"
  If Vproc <> vbnull Then 
   XLtab (6, 0) = Vproc
  ElseIf Vcard  <> vbnull Then
   XLtab (6, 0) = Vcard 
  End If
   XLtab (6, 1) = Vmem &" MB " 
   '--- Vrification du paramtre systme (W7 et W8) LastAccessUpdate
 
     If  (Mid(OsName, 19, 2)  <> "XP"  and Mid(OsName, 20, 5) <> "Vista")  Then
      For i =1 to 3            
       Key_value = objShell.RegRead(Lau)
       If Err.Number = 0 Then 
               DbgTxt =  "i= " &i &" Key = " & Key_value
          If  i=1 and Key_value = 0 Then Exit For
          If  i=2 and Key_value = 0 Then
                Msg =   " Rebootez la machine et relancez le script "
                Boutons = vbCritical
                Rep = MsgBox (Msg, Boutons)
                WScript.Quit()
          Else     
           If Key_value = 1 Then
             Titre = " Option systme  modifier "
             Boutons= vbYesNoCancel + vbExclamation
             Msg =  "  LastAccesUpdate non activ  (0 = activ,  1= dsactiv)" &vbcrlf 
             Msg = Msg & "  Cliquez sur OUI : modification automatique de l'option"  &vbcrlf
             Msg = Msg & "  ou modification manuelle : En mode CMD administrateur, tapez : "  &vbcrlf
             Msg = Msg & "              fsutil behavior set DisableLastAccess 0 "  &vbcrlf
             Msg = Msg & "  puis cliquez sur NON"
             Rep = MsgBox (Msg, Boutons, Titre)
                If Rep = vbCancel Then
                  msgbox  " Script abandonn "
                  WScript.Quit()
                End If
                If Rep =  vbYes Then 
                  objShell.RegWrite Lau, 0 , "REG_DWORD"
                End If 
                If Rep =  vbNo Then 
                  msgbox  " controle de la valeur "
                End If
           End If
          End If
       End If
      Next
                If Key_value =1 Then
                 msgbox  "Option non modifie : Script abandonn "
                 WScript.Quit()
                End If
     End If
 '----------------------------------------------------------------------------------------------------------------------------------
 Debug = DbgSave
 '   
 '--- Choix de l'application

     InstallLocation = Appli

  Select Case Choix
   Case "cs5.5"
     'Premiere Pro CS5.5
     CS_col = CS5_col
     Version = Prem55_key 
     Prem_name = Prem55_Name
     Alt_ver = CS5_key
     InstallKey = Prem55_instal
     Medias_cache = Prem55_cache 
     Prog_Dir = Prem55_dir
     Exec_name   =  Prem55_exe
     File_Parms = AppData & Prem55_prefs
     Presets_Dir = AppData & Prem55_presets
     Preset_File = Preset_Fileprefix &DVD &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export DVD
     Preset_File = Preset_Fileprefix &Bluray &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export Bluray
     Preset_File = Preset_Fileprefix &Avchd &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export AVCHD
     Presets_Dir = AppData & Prem55_seq
     Preset_File = Preset_Fileprefix  &Choix  &".sqpreset"
     call Presets_copy                                                    ' Creation Presets de Squence
     Proj_suffix = ".prproj"
     If Titre_suffix = "" then  Titre_suffix =  ".prtl"
     Rendu = Prem55_rendu &"Test_"
     Rendu_prefix = "CS5.5"
     Rendu_suffix =".PRV"

   Case "cs6"
     'Premiere Pro CS6
     CS_col = CS6_col
     Version = Prem60_key
     Prem_name = Prem60_Name
     Alt_ver = CS6_key
     InstallKey = Prem60_instal
     Medias_cache = Prem60_cache 
     Prog_Dir = Prem60_dir    
     Exec_name   = Prem60_exe
     File_Parms = AppData & Prem60_prefs
     Presets_Dir = AppData & Prem60_presets
     Preset_File = Preset_Fileprefix &DVD &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export DVD
     Preset_File = Preset_Fileprefix &Bluray &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export Bluray
     Preset_File = Preset_Fileprefix &Avchd &Choix  &".epr"
     call Presets_copy                                                    ' Creation Presets d'export AVCHD
     Presets_Dir = AppData & Prem60_seq
     Preset_File = Preset_Fileprefix  &Choix  &".sqpreset"
     call Presets_copy                                                    ' Creation Presets de Squence
     Proj_suffix = ".prproj"
     If Titre_suffix = "" then  Titre_suffix =  ".prtl"
     Rendu = Prem60_rendu &"Test_"
     Rendu_prefix = "CS6"
     Rendu_suffix =".PRV"
     
   Case "edius60"
     'Edius 6.01  6.08
     Version = Edius60_key_32
     Alt_ver = ""
     If OsType ="64" Then Version = Edius60_key_64
     InstallKey = Edius60_instal   
     Prog_Dir = Edius60_dir
     Exec_name   = Edius60_exe
     File_Parms = AppData & Edius60_prefs &"CurrentSettings.esp"
     Keyname = Edius_UserP
     Value = ""
     Nval = Edius_UserN
     Vpos= 1
     Fparm = File_Parms
     call Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)                 ' Update Current Setting
     Presets_Dir = AppData & Edius60_prefs  &"Project Presets"         
     Preset_File = Preset_Fileprefix &Choix &".epp"
     call Presets_copy                                                    ' Creation Preset Projet  
     Presets_Dir = AppData & Edius60_prefs  &Edius_User
     Preset_File = "SpecialPresets.tpd"
     call Presets_copy                                                    ' Creation Presets d'export DVD, Bluray, AVCHD
     Presets_Dir = AppData & Edius60_prefs  &Edius_User &"\Setting" 
     Preset_File = "Setting.esp"
     call Presets_copy                                                    ' Creation Preset User setting
     Preset_File = Edius_Guiset 
     call Presets_copy                                                    ' Creation Preset interface utilisateur
     Proj_suffix = ".ezp"
     If Titre_suffix = "" then  Titre_suffix =  ".etl"
     Rendu = Edius60_rendu
     Rendu_prefix = ""
     Rendu_suffix =""

   Case "edius65"
     'Edius 6.50  6.53
     Version = Edius65_key_32
     Alt_ver = ""
     If OsType ="64" Then Version = Edius65_key_64
     InstallKey = Edius65_instal   
     Prog_Dir = Edius65_dir
     Exec_name   = Edius65_exe
     File_Parms = AppData & Edius65_prefs &"CurrentSettings.esp"
     Keyname = Edius_UserP
     Value = ""
     Nval = Edius_UserN
     Vpos= 1
     Fparm = File_Parms
     call Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)                 ' Update Current Setting
     Presets_Dir = AppData & Edius65_prefs  &"Project Presets" 
     Preset_File = Preset_Fileprefix &Choix  &".epp"
     call Presets_copy                                                    ' Creation Preset Projet
     Presets_Dir = AppData & Edius65_prefs  &Edius_User 
     Preset_File = "SpecialPresets.tpd"
     call Presets_copy                                                    ' Creation Presets d'export DVD, Bluray, AVCHD
     Presets_Dir = AppData & Edius65_prefs  &Edius_User &"\Setting" 
     Preset_File = "Setting.esp"
     call Presets_copy                                                    ' Creation Preset User setting
     Preset_File = Edius_Guiset
     call Presets_copy                                                    ' Creation Preset interface utilisateur
     Proj_suffix = ".ezp"
     If Titre_suffix = "" then  Titre_suffix =  ".etl"
     Rendu = Edius65_rendu
     Rendu_prefix = ""
     Rendu_suffix =""

   End Select
 Debug = DbgSave
 '----------------------------------------------------------------------------------------------------------------------------------
 '--- rpertoire de fichiers temporaires
  Uprof = "%USERPROFILE%"
  Ftemp =  trim(UserEnvVars("TEMP"))
  Temp   = objShell.ExpandEnvironmentStrings(Uprof)
  If Right(Ftemp,1) <> "\" Then Ftemp = Ftemp & "\"
  If Left (Ftemp, 13) =  Uprof  Then
   Ftemp = Temp & Right ( Ftemp, Len(Ftemp) -13)
  End If
  Call Disk_Type (Ftemp, D_Mode)
  XLtab (3, 0) = D_Mode
  SysDisk = objShell.ExpandEnvironmentStrings("%systemroot%")
  Call Disk_Type (SysDisk, D_Mode)
  XLtab (4, 0) = D_Mode
 '--- initialisation  de Gpu-Z
 '
   GpuZ_instal_dir = objShell.RegRead(GpuZ_key & "\Install_Dir")
   If Err <>0  or GpuZ_instal_dir = "no" Then
      msgbox "GPU-Z non install" &vbcrlf & vbcrlf &"Utilisation de GPU-Z version 0.7.1.0" 
      GpuZ_instal_dir = DirPath &Src_Test &"Pgm\"  
   End If 
   If Right(GpuZ_instal_dir,1) <> "\" Then GpuZ_instal_dir = GpuZ_instal_dir & "\"    
      GpuZ_prog = GpuZ_instal_dir & GpuZ_exe 
      If Not oFS.fileExist (GpuZ_prog) Then               ' Test si le programme est valide                                                             
       GpuZ_instal_dir = DirPath &Src_Test &"Pgm\"        ' Sinon 
       GpuZ_prog = GpuZ_instal_dir & GpuZ_exe             ' on prend le pgm par dfaut
      End If
      GpuZ_ver = oFS.GetFileVersion(Gpuz_prog) 
      GpuZ_log = Ftemp & "GPU-Z Sensor Log.txt"
      objShell.RegWrite GpuZ_key &"\Logfile"  , GpuZ_log , "REG_SZ"
      DbgTxt = (" Gpu-Z dir  = " &GpuZ_instal_dir & " v = " &Gpuz_ver  &"  Log = " &GpuZ_log) : Call DbgMsg (DbgTxt, 2)
   If oFS.FileExists (GpuZ_log) Then  oFs.DeleteFile GpuZ_log, true
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Localisation de l'Application
 '
 On Error Resume Next
    Ret = 0
    Projet = DirPath  & Proj_Test & "Test_" &Choix  & Proj_suffix
    DbgTxt = "Verkey = " &version & vbcrlf &"Altkey = " &Alt_ver  : Call DbgMsg (DbgTxt, 3)
    InstallLocation = objShell.RegRead(Version & InstallKey ) 
    If Err.Number <> 0 Then
        If Left(Choix, 2) = "cs" Then
         Err.Clear
         InstallLocation = objShell.RegRead(Alt_ver & InstallKey ) 
         If Err.Number <> 0 Then                               ' Pas d'entre trouve avec la cl, on balaye toute la liste de Uninstall
            Err.Clear
            Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &"." & "\root\default:StdRegProv")
            strKeyPath = "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\"
            Ret =  oReg.EnumKey (HKEY_LOCAL_MACHINE, strKeyPath, keylist)
            If (Ret=0 and IsArray(Keylist)) then
             Ret = - 1                                         ' Pas d'enre trouve
             For Each subkey In keylist
              Reg_Key = "HKLM\" &strKeyPath & subkey &"\DisplayName"
              Prog_Ver = objShell.RegRead(Reg_Key ) 
              DbgTxt =  ("Prem_Name = " &Prem_Name  &"  Prog_ver = " &Prog_Ver)  : Call DbgMsg (DbgTxt, 3)
              If Left (Prog_Ver, Len(CS_col)) = CS_col Or Left (Prog_Ver, Len(Prem_Name)) = Prem_Name Then
                Reg_Key = "HKLM\" &strKeyPath & subkey &"\InstallLocation"
                DbgTxt = "Regkey = " &Reg_Key  : Call DbgMsg (DbgTxt, 3)
                InstallLocation = objShell.RegRead(Reg_Key) 
                If Err.Number = 0 Then 
                     If InstallLocation = Prem_instal_def Then InstallLocation = Prem_instal_dir
                     Prog_Exe = InstallLocation &Prog_Dir & Exec_name
                     If oFs.FileExists(Prog_Exe) Then          ' test de la prsence de l'executable
                      Ret = 0
                      Exit For
                     End If
                End If
              End If
             Next
             If Ret = -1 Then
              InstallLocation = Prem_instal_dir                ' Installation par dfaut
              Prog_Exe = InstallLocation &Prog_Dir & Exec_name
              If oFs.FileExists(Prog_Exe) Then Ret = 0         ' test de la prsence de l'executable
             End If         
            End If
         End If
        End If
      If Err.Number <> 0 Or ret <> 0 Then
        Err.Raise 53,,Appli &" :  Application non instale, ou non encore supporte"
        Test_Erreur "Selection Application"

      End If
    End If
 If InstallLocation = Prem_instal_def Then InstallLocation = Prem_instal_dir  
   DbgTxt = "Instal_loc  : " &InstallLocation  : Call DbgMsg (DbgTxt, 3)
 ' Call Disk_Type (InstallLocation, D_letter, D_Mode)
 Texte =  "TEST_" &Appli &" : " &Comment &vbcrlf &vbcrlf
 Texte =  Texte &" Processeur  : " &Cpu &"  " &Cpu_F &"/" &Cpu_Fm &" Mhz, Mmoire " &Msize &" MB  " &Mfreq &" Mhz" & vbcrlf
 Texte =  Texte &" Carte vido : " &Vcard &"/ " &Vmem   &" MB " & vbcrlf
 Texte =  Texte &"  Systme    : " &Osname &" " &OsType  &" bits" &vbcrlf &vbcrlf
 Texte =  Texte & " Rpertoire de Travail  : "   &DirPath &vbcrlf  
 Texte =  Texte & " Rpertoire de Logs     : "   &Logpath &vbcrlf
 Texte =  Texte & " Version pgm de GPU-Z   : "   &GpuZ_ver &vbcrlf       
 Texte =  Texte & " Fichier Log de GPU-Z   : "   &GpuZ_log &vbcrlf  
 Texte =  Texte & " Fichiers temporaires   : "   &Ftemp &vbcrlf &vbcrlf 

 Time1 = Now
 FirstTime = Now
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Creation et Copie des rperoires de sources
 '
  DbgTxt =  "File copy started."  : Call DbgMsg (DbgTxt, 1)

  Titre = "Rpertoire des sources"
  Msg = "Rpertoire de destination des sources, par dfaut" &vbcrlf &"(indiquer un autre rpertoire existant, si ncessaire)"
  Msg = Msg &vbcrlf &vbcrlf &"Attention :" &vbcrlf &" le rpertoire cache par dfaut sera effac"
  defaultValue1 = Dirpath
  Rep = InputBox(Msg, Titre, defaultValue1 )
   ' If user has clicked Cancel, quit script
    If Rep = "" Then 
       msgbox  " Script abandonn "
       WScript.Quit()
    Else
       SrcPath = RTrim(Rep)
       If Right(SrcPath,1) <> "\" Then SrcPath = SrcPath & "\"
       If Not oFs.FolderExists(SrcPath) Then 
        msgbox  " Rpertoire non trouv " & SrcPath
        WScript.Quit()
       End If
    End If

    Rep = Projet_Src
    Dir = SrcPath & Rep
    Msg = "Creation rpertoire " &Dir &vbcrlf &vbcrlf &" Et copie des sources : Videos, Titres et Musiques"
    Msg = Msg &vbcrlf &vbcrlf &"(spcififiez ce rperoire lors de la demande de localisation dans l'application)"
    MsgBox Msg
    Call Dir_Create (Dir)
    Call Disk_Type (Dir, D_Mode)
   Rep = Projet_Src & "\Videos"
   Dir = SrcPath & Rep
   Call Dir_Create (Dir)

         From = DirPath  &Src_Test & "V1Test" & Video_suffix 
       For i =0 to Maxclips1 -1
         Dest = SrcPath &Rep  &"\V1Test" &i  & Video_suffix
         DbgTxt = ("F= " &From &vbcrlf &"D= " &Dest) : Call DbgMsg (DbgTxt, 5)
         oFs.Copyfile From, Dest, True
       next 
         Test_Erreur "Copie V1"
         From = DirPath  &Src_Test & "V2Test" & Video_suffix
       For i =0 to Maxclips2 -1  
         Dest = SrcPath &Rep  &"\V2Test" &i  & Video_suffix
         DbgTxt = ("F= " &From &vbcrlf &"D= " &Dest) : Call DbgMsg (DbgTxt, 5)
         oFs.Copyfile From, Dest, True
       next 
         Test_Erreur "Copie V2"

   Rep = Projet_Src&"\Titres"
   Dir = SrcPath & Rep
   Call Dir_Create (Dir)

         From = DirPath  &Src_Test  & "Titres_" & Left(Choix, 2)
         Dest = SrcPath  &Rep 
         DbgTxt = ("F= " &From &vbcrlf &"D= " &Dest) : Call DbgMsg (DbgTxt, 5)
         oFs.Copyfolder From, Dest, True
  
         From = DirPath  &Src_Test & "Titre" & Titre_suffix
       For i =0 to Maxtitles - 1
         Dest = SrcPath  &Rep &"\Titre" &i & Titre_suffix
         DbgTxt = (Dest) : Call DbgMsg (DbgTxt, 5)
         oFs.Copyfile From, Dest, True
       next 
         Test_Erreur "Copie Titres"

   Rep = Projet_Src&"\Musiques"
   Dir = SrcPath & Rep
   Call Dir_Create (Dir)
  
         From = DirPath  &Src_Test  & "Musiques"
         Dest = SrcPath  &Rep 
         DbgTxt = ("F= " &From &vbcrlf &" D= " &Dest) : Call DbgMsg (DbgTxt, 5)
         oFs.Copyfolder From, Dest, True
         Test_Erreur "Copie Musiques"
 '
 '--- Calcul temps de copie des sources
 '
    nb = UBound(Source_Inc,1)
    ReDim  Files_Inc(nb)
  For i= 0 to nb
   Files_Inc (i) = Source_Inc (i)
   DbgTxt =  ("i = " &i &" S= " &Source_Inc(i) &"D= "  &Files_Inc(i) ) : Call DbgMsg (DbgTxt, 6)
  Next

   Call Scan_Dir (SrcPath & Projet_Src, FirstTime, DebTime, FinTime, Duree, AccesTime, FirstFile,  LastFile)
   DbgTxt = (" LastFile= " &LastFile &" Duree = " &Duree &" AccesTime = " &AccesTime ) : Call DbgMsg (DbgTxt, 3)
   Tsrc = Duree
   Time2 = Now
   Tinit = DateDiff ("s", Time1, Time2)
   Texte = Texte & "Dure initialisation    = "  & Tinit & " sec, dont "
   Texte = Texte & "Dure copie sources = " &Tsrc &" secondes" &vbcrlf &vbcrlf
   XLtab (7, 1) = Tinit
   XLtab (8, 1) = Tsrc
   XLtab (8, 0) = D_Mode
   Debug = DbgSave
   DbgTxt =  "File copy ended."  : Call DbgMsg (DbgTxt, 1)
  '----------------------------------------------------------------------------------------------------------------------------------
  ' --- Creation du rpertoire d'exports par dfaut
  '
   ExpPath = DirPath &  Exp_Proj
   If Not oFs.FolderExists(ExpPath) Then  Call Dir_Create (ExpPath)
    Test_Erreur "Dir_Exp"
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Localisation et suppression rpertoire caches (si pas repertoire source)
 '
    If Left(Choix, 5) = "edius" Then
 '      Dans Edius, le cache est toujours avec les rpertoires sources
      CacheFiles_Dir = SrcPath & Projet_Src
    Else
 '     Dans Premiere les caches sont dfinis dans les prfrences de l'application
           Key_value  = objShell.RegRead(Medias_cache & "FolderPath") 
           If Err.Number <> 0 Then
             DbgTxt =  ( Choix &" Rpertoire Cache non dfini, Err = " &Err.Number  ) : Call DbgMsg (DbgTxt, 3)
             WScript.Quit()
           End If
           If Right(key_value,1) <> "\" Then key_value = key_value & "\"
            Cache_Dir = Key_value &"Media Cache"    
            DbgTxt = ( " Rpertoire cache mdias : "  & Cache_Dir) : Call DbgMsg (DbgTxt, 3)
           If oFs.FolderExists(Cache_Dir) Then oFs.DeleteFolder Cache_Dir, True 
            Key_value  = objShell.RegRead(Medias_cache & "DatabasePath") 
           If Err.Number <> 0 Then
            DbgTxt =  ( Choix &" Rpertoire Cache Files non dfini, Err = " &Err.Number  ) : Call DbgMsg (DbgTxt, 3)
            WScript.Quit()
           End If
           If Right(key_value,1) <> "\" Then key_value = key_value & "\"
            CacheFiles_Dir = Key_value &"Media Cache Files"    
            DbgTxt = ( " Rpertoire cache mdias : "   & CacheFiles_Dir) : Call DbgMsg (DbgTxt, 3)
           If oFs.FolderExists(CacheFiles_Dir) Then oFs.DeleteFolder CacheFiles_Dir, True 

            '     Test du choix par dfaut : Uniformisation prs des sources 
            Fparm = File_Parms
            Keyname = Prem_cache_Flag
            KeyEnd = ""  : index =1        
            call Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)       
           If Value = "true"  Then
            CacheFiles_Dir = SrcPath & Projet_Src
           End If
    End If
    Call Disk_Type (CacheFiles_Dir, D_Mode)
    XLtab (11, 0) = D_Mode
    Debug = DbgSave
    DbgTxt = (" Rpertoire cache mdias : "  & CacheFiles_Dir) : Call DbgMsg (DbgTxt, 3)
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Localisation et suppression rpertoire de prvisualisations
 '
     Rep =   DirPath & Proj_Test
      '      Dans Edius,  le rpertoire de rendu est toujours dans le rpertoire du projet (sous-rep "rendered")

     If Left(Choix, 2) = "cs" Then     
      '      Dans Premiere le rpertoire de rendu peut tre dfini par l'utilisateur, ou dans le dossier du projet
      '      Si c'est le premier lancement aprs cration du rpertoire Test_perfs, on force le rendu dans le dossier projet
            set oF = oFs.Getfile(Projet)        
            Proj_Create = oF.DateLastModified                   ' Date de la derniere modification du projet
            Fparm = Projet
            DbgTxt = (Fparm &vbcrlf &"DateTest = " &Test_Create &" Dateproj = " &Proj_Create) : Call DbgMsg (DbgTxt, 4)
          If Proj_Create < Test_Create Then                          ' C'est la premiere fois qu'on lance le test
            Keyname = Prem_R_audio   
            Vpos=0                                                                                                 
            Nval = Vbtab &vbtab &Keyname & SameasProj &"</" & Right (Keyname, Len(Keyname) -1) 
            Call Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)
            Keyname = Prem_R_video 
            Vpos=0                                                                                                 
            Nval = Vbtab &vbtab &Keyname & SameasProj &"</" & Right (Keyname, Len(Keyname) -1) 
            Call Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)
          Else
            Keyname = Prem_R_video
            KeyEnd = "" : index =1
            call  Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)  
            If Vlen <> 0 And Value <> SameasProj Then
               Rep = Value           
            End If
          End If


     End  If	
     Prev_Dir = Rep  &Rendu  &Rendu_prefix  &Rendu_suffix    
    If oFs.FolderExists(Prev_Dir) Then oFs.DeleteFolder Prev_Dir, True 
     DbgTxt = ("Rpertoire rendus = "  &Prev_Dir) : Call DbgMsg (DbgTxt, 3)
     Debug = DbgSave
     Test_Erreur "Prev_Dir"
 '-----------------------------------------------------------------------------------------------------------------------------------
 ' --- Lancement idu Projet avec le produit choisit
       FirstRun  = Now    ' Heure de lancement de l'application
       Time1 = Now        ' Heure de fin de lecture des sources par dfaut
       Time2 = Now        ' Heure de fin de lecture des caches par dfaut
       Time3 = Now        ' Heure de fin de cration des rendus par dfaut
       XLtab (2, 1) = FirstRun
 '--- Lancement de GPU-Z
       Prog_run = quote & GpuZ_prog & quote 
       Ret  = WshShell.Run  ( Prog_run, 7 ,False) 
           
                Prog_Exe = InstallLocation &Prog_Dir & Exec_name
                Prog_ver = oFS.GetFileVersion(Prog_Exe)
                Texte = Texte & "Application : " & Prog_Exe & "  Version = " &Prog_ver &vbcrlf
                Texte = Texte & "     Projet : " & Projet &vbcrlf &vbcrlf
                Texte = Texte & "Fichier de prfrences  : "  & File_Parms  &vbcrlf
                Texte = Texte & "Rpertoire sources      : "  & SrcPath  & Projet_Src&vbcrlf
                If Cache_dir <> "" Then Texte = Texte & "Rpertoire cache D.b.   : "  & Cache_Dir &vbcrlf 
                Texte = Texte & "Rpertoire cache mdias : "  & CacheFiles_Dir &vbcrlf &vbcrlf
                Texte = Texte & "Lancemement application = "  & FirstRun &vbcrlf
                oLog.WriteLine Texte
 
 '--- Lancement initial de l'Application
      
       Prog_run = quote & Prog_Exe & quote   &" "  & quote & Projet & quote    
       DbgTxt = (" Debug =  " &Debug &vbcrlf &"Appel application  "& Prog_run &" " & Firstrun) : Call DbgMsg (DbgTxt, 2)
    If Debug  >= 0 Then
       Ret  = WshShell.Run  ( Prog_run, 2 ,True) 
    End If
  
      Time4 = Now         ' Heure de retour de l'application   
      DbgTxt = ("Retour application " & Prog_run &" " &Time4 ) : Call DbgMsg (DbgTxt, 2)

      strProcessKill = GpuZ_exe                               ' Arrt de GPU-Z pour lire la log
      call Kill_exe (strProcessKill ) 
      objShell.RegWrite GpuZ_key &"\Logfile"  , "" , "REG_SZ"  ' suppression du logging
      Test_Erreur "Kill GPU-Z"

 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Test de l'utilisation de CUDA
 '
         XLtab (10, 1) = "N.P"            ' Dans edius , l'utilisation de Cuda est Non Paramtrable
         Texte = "Acclration CUDA non paramtrable" &vbcrlf
           If Left(Choix, 2) = "cs" Then
             Keyname = Prem_acceler
             KeyEnd = "" : index = 1
             call Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)      
               If Vlen <> 0 Then
                   XLtab (10, 1) = "non"
                   Texte = "Acclration CUDA non active" &vbcrlf
                  If  Mid( Value, 16,  Len(Prem_cuda) ) = Prem_cuda  Then
                    Texte = "Acclration CUDA active: " & Mid( Value, 16, Vlen-15) &vbcrlf 
                    XLtab (10, 1) = "oui"
                  End If           
               End If
           End If
            oLog.WriteLine Texte
         Test_Erreur "Test Cuda"
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Calcul de la dure de lancement du Projet : on cherche la fin d'criture  des caches 
 '
  Err.Clear
 '
 '  Files_Inc = Cache_Inc      Liste d'Inclusion de fichiers des caches
	nb = UBound(Cache_Inc,1)
    ReDim  Files_Inc(nb)
  For i= 0 to nb
   Files_Inc (i) = Cache_Inc (i)
   DbgTxt =  ("i = " &i &" S= " &Cache_Inc(i) &" D= "  &Files_Inc(i) ) : Call DbgMsg (DbgTxt, 6)
  Next
    call Scan_Dir (CacheFiles_Dir, FirstRun, DebTime, FinTime, Duree, AccesTime,  FirstFile,  LastFile)
    DbgTxt =  ("LastAccess Caches = " & AccesTime & " Dure = " &Duree &vbcrlf) : Call DbgMsg (DbgTxt, 3)
    Duree1 = "N.A"                               ' Si l'application n'a pas t lance ou uniformisation non termine
 If Duree > 0 Then
   Duree1 = DateDiff ("s", FirstRun, FinTime)    ' temps de lancement du projet
   Duree2 =  Duree
   Time2 = FinTime      ' Heure de fin de cration des caches
 End If
 If Duree1 > 0 Then   
    Texte = "Dure lancement initial = " & Duree1 
 Else 
    Texte = "Application non lance ou Uniformisation non termine"
 End If
 If Duree2 > 0 Then
           Texte = Texte &" s, dont Lecture sources / Uniformisation = " &Duree2 &" s" & vbcrlf  
 End If
       XLtab (9, 1) = Duree1
       XLtab (11, 1) = Duree2                 
       DbgTxt =  Texte  : Call DbgMsg (DbgTxt, 2)
       oLog.WriteLine Texte
 '
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Calcul de la dure des rendus
 '
  Debug = DbgSave
 ' Files_Inc = Rendu_Inc	Liste d'Inclusion de fichiers des rendus
	nb = UBound(Rendu_Inc,1)
    ReDim  Files_Inc(nb)
  For i= 0 to nb
   Files_Inc (i) = Rendu_Inc (i)
   DbgTxt =  ("i = " &i &" S= " &Rendu_Inc(i) &" D= "  &Files_Inc(i) ) : Call DbgMsg (DbgTxt, 6)
  Next

 Rep =   Prev_Dir

  DbgTxt = ("Rpertoire rendus = "  &Prev_Dir) : Call DbgMsg (DbgTxt, 3)
  Texte = "Pas de rendu effectu"
  XLtab (12, 1) = 0
 If  oFs.FolderExists(Rep) Then
    Call Disk_Type (Rep, D_Mode)
    call Scan_Dir (Rep, FirstRun, DebTime, FinTime, Duree, AccesTime,  FirstFile,  LastFile)
    DbgTxt =  ("LastAccess Rendus = " & AccesTime & " Dure = " &Duree &vbcrlf) : Call DbgMsg (DbgTxt, 3)
    Texte = "Repertoire Rendus  = "   & Rep &vbcrlf
    If Duree <> 0 Then 
        XLtab (12, 1) = Duree
        XLtab (12, 0) = D_Mode
       If FinTime > Time3 Then Time3 = FinTime  ' Heure de fin des rendus
       Texte = Texte &"     Dure rendus  = " & Duree & " secondes " & string(5,vbtab)

       Call GpuZ_moy (DebTime, FinTime, G_load_moy, G_load_Max) 
       Texte = Texte &"GPU Load moy = " &CLng(G_load_moy)& " %" &vbTab &"GPU Load max = " &CLng(G_load_Max) &" %" &vbTab
       XLtab (13, 1) = CLng(G_load_moy)
       XLtab (14, 1) = CLng(G_load_max)
    Else 
       Texte = Texte &"  Aucun fichier de rendu cr " &vbcrlf
    End If 
  
 End If
      DbgTxt =  Texte   : Call DbgMsg (DbgTxt, 3)    
      oLog.WriteLine Texte
      Texte = vbcrlf
 '
 '-----------------------------------------------------------------------------------------------------------------------------------
 '--- Calcul de la dure des exports 
 '
        Debug = DbgSave
        Err.Clear
 ' Files_Inc = Export_Inc     Liste d'Inclusion de fichiers des exports
	nb = UBound(Export_Inc,1)
    ReDim  Files_Inc(nb)
  For i= 0 to nb
   Files_Inc (i) = Export_Inc (i)
   DbgTxt =  ("i = " &i &" S= " &Export_Inc(i) &" D= "  &Files_Inc(i) ) : Call DbgMsg (DbgTxt, 6)
  Next
        ExpPath = DirPath &  Exp_Proj
    
   If Left(Choix, 2) = "cs" Then
    ' cas de Premiere  : le dernier rpertoire accd est mis  jour dans le fichier Adobe Premiere Pro Prefs
             Fparm = File_Parms
             Keyname = Prem_Prefs_Exp
             KeyEnd = ""   : index =1         
             call Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)      
             If Vlen <> 0 Then
                ExpPath = Value         
             End If         
   Else 
    ' cas de Edius : le dernier rpertoire accd est mis  jour dans le fichier CtsGuiSetting.esp
          Fparm =  Presets_Dir &Edius_Guiset
          Keyname = Edius_filekey
          KeyEnd ="</" & Right (Keyname, Len(Keyname) -1)      
          index =1
          call Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)
     If index >0 Then
          Keyname = Edius_foldkey
      Do While index >0                                                                                        
          call Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index)                     
            If index=0 and Value ="" Then Exit Do
          If Vlen > 0  Then
               ExpPath = Value    
            If Right(ExpPath,1) <> "\" Then ExpPath = ExpPath & "\"
            If  oFs.FolderExists(ExpPath) Then 
             Set oFolder = oFs.GetFolder (ExpPath)         
             AccesTime = oFolder.DateLastModified
              DbgTxt =  ("T = " &Time2 &" - Exp :  " &ExpPath &"  aTme =  " & AccesTime &" " &Err.Number) : Call DbgMsg (DbgTxt, 4)
              If AccesTime > Time2 Then   ' on teste si le dossier trouv a t modifi
               Exit Do
              Else 
               ExpPath = ""
              End If  
            End If
               index = index+1         
          End If 
      Loop
     End If
         ' Il faut valider le rpertoire d'export
           defaultValue1 = ExpPath
           Titre = " Localisation du rpertoire Exports"
           Msg = "Rpertoire Exports non confirm, prcisez son emplacement"
           ExpPath = InputBox (Msg, Titre, defaultValue1)
           DbgTxt =  ("2 - Exp : " & ExpPath &"  " & Err.Number) : Call DbgMsg (DbgTxt, 4)
   End If

  If Right(ExpPath,1) <> "\" Then ExpPath = ExpPath & "\"
     Texte  =   vbcrlf &  "Rpertoire exports = " &ExpPath &vbcrlf 
     Texte = Texte & "               (*) = fichier r-crit, Dure approximative par excs" &vbcrlf &vbcrlf
     i = 0

 If  oFs.FolderExists(ExpPath) Then
     Call Disk_Type (ExpPath, D_Mode)
     XLtab (15, 0) = D_Mode
     XLtab (21, 0) = " "
        Set oFolder = oFs.GetFolder (ExpPath) 
        FirstTime = Time1                    ' Heure de dbut des exports: fin de creation des sources (dans Edius , on peut faire l'export avant les rendus)
    For Each  oF In oFolder.files   
      ExpFile = ExpPath  & oF.Name
      ModFlag = " "
      Duree = 0
      DbgTxt = (" T= " &FirstTime &" Export File = " & ExpFile ) : Call DbgMsg (DbgTxt, 4)
     call File_Time (oF, FirstTime, DebTime, FinTime,  Duree, ModFlag,  LastFile)
      If Duree <> 0 Then 
        If DebTime < Time2 Then
           Texte = Texte &vbcrlf & " *** Export dmarr avant la fin de l'uniformisation ***" &vbcrlf
        End If
        i =  i +1
        If i > UBound (XLtab, 2) Then
             j = i + 50
             ReDim Preserve  XLtab (21, j) 
        End If          
           XLtab ( 15, i ) = Lastfile
           XLtab ( 17, i ) = Duree 
           Texte = Texte &vbcrlf & "Fichier export   : " &Lastfile  &vbTab &" Dure export = " & Duree & " secondes " & ModFlag &vbTab
           Call Info_File ( ExpPath, Lastfile)
             Flong = DateDiff ("s", "00:00:00", Ftab(27) )                          ' Longueur du film export (20 mn par dfaut)
             XLtab ( 16, i ) = Flong 
             Time4 = DebTime
             Time5 = FinTime
           If right (lastfile, 3) <> "ac3" And  right (lastfile, 3) <> "aac" Then   ' calcul de la charge GPU
             Call GpuZ_moy (Time4, Time5, G_load_moy, G_load_Max) 
             Texte = Texte &"GPU Load moy = " &CLng(G_load_moy)& " %" &vbTab &"GPU Load max = " &CLng(G_load_Max) &" %" &vbTab
             XLtab (18, i) = CLng(G_load_moy)
             XLtab (19, i) = CLng(G_load_max)
           Else 
             Texte = Texte & string(6,vbtab)
           End If
             If Flong > 0 Then 
              TRatio = FormatNumber (Duree / Flong) 
              XLtab (21, i) = TRatio
              Texte = Texte & " Ratio/temps rel = " &TRatio 
             End If 
      End If
    Next
     Debug = DbgSave
     Nbexp = i
     If Nbexp = 0 Then   Texte = Texte & "  Aucun fichier export gnr"                                            
 Else
    Texte = "  Pas de fichiers export gnrs"  &vbcrlf
 End If

     oLog.WriteLine Texte
     Texte = vbcrlf
     Debug = DbgSave
     Test_Erreur "Export"
 '
 '-----------------------------------------------------------------------------------------------------------------------------------
 '
    XL_test   ' Test de la prsence d'Excel ou OOo sur la machine locale  (pas de support pour Excel starter : pas d'interface VBS)

  If XLflag = False  Then 
   Texte = Texte &vbcrlf &" Excel non disponible, pas de rapport cumulatif" &vbcrlf 
  Else 
   Texte = Texte &vbcrlf &vbcrlf & "  Rapport Excel    = "  & XLfile &vbcrlf  
  End If

 '-- Fin du test : Affichage des rsultats
   oLog.WriteLine Texte
   oLog.close
   Set oLog = oFs.OpenTextFile(LogPath & Logfile,8)                   ' R-open LogAppend mode 
   Titre = " Affichage des rsultats"
   Msg = " Le fichier Log a t cr : " &LogFile &vbcrlf  &vbcrlf
   Msg = Msg &" OUI : pour afficher les rsultats, NON pour ignorer"
   Boutons= vbYesNo + vbQuestion
   Reply = MsgBox (Msg, Boutons, Titre)
  If Reply = vbYes Then
         RetNote = Null
         Prog_run = quote & "%SystemRoot%\system32\" &NotePad &quote &" " &quote &LogPath &Logfile &quote
         RetNote  = WshShell.Run  ( Prog_run, 4 ,False) 

 ' --- Fin du test : Recap dans un fichier Excel
 ' 
      If XLtype = 1  Then 
         Set objExcel = CreateObject("Excel.Application")    
         Set oWB = objExcel.Workbooks.Open (XLfile)
         Set oWS =  oWB.WorkSheets(1)  
         oWS.Activate
         oWS.Range("B4").select
         objExcel.ActiveWindow.FreezePanes = "True"
         ' recherche de la dernire ligne crite                                                                                     
         With oWS.UsedRange
          Lastline =  .Row + .Rows.Count
         End With     
         If Nbexp = 0 Then Nbexp = 1   ' au moins une ligne dans le fichier excel
         Set oWS =  oWB.WorkSheets(1) 
         For i = 0 to Nbexp
             k = Lastline+i+1
           For j = 1 to UBound (XLtab, 1)
            XLtab (j, i) =  " " &  XLtab (j, i) &" "  
            oWS.Cells (k ,j).Value = XLtab (j, i)   
           Next
           If XLtab(21, i) = "  " Then
            oWS.Cells (k,21).Formula = "= Q" &k &"/P" &k
           End If
         Next

         oWS.Columns.AutoFit()   
         objExcel.Application.DisplayAlerts = False 
         objExcel.Application.Visible = True
      End If	
        Test_Erreur "XL 1"

      If XLtype = 2  Then 
        Set oSM = WScript.CreateObject("com.sun.star.ServiceManager")
        Set oDesk = oSM.createInstance("com.sun.star.frame.Desktop")   
        Set Sargs(0) = oSM.Bridge_GetStruct("com.sun.star.beans.PropertyValue")
        Sargs(0).Name = "FilterName"
        Sargs(0).Value = "MS Excel 97"
        XLurl = ConvertToURL(XLfile)
        Set oWB = oDesk.loadComponentFromURL(XLurl , "_blank", 0, Sargs)
        Set oWS = oWB.createInstance("com.sun.star.sheet.Spreadsheet")
        Set oWS = oWB.getSheets.getByIndex(0) 
        Call   OWB.getCurrentController.freezeAtPosition(1, 3)
        ' recherche de la dernire ligne crite 
        oWS.Columns.OptimalWidth = True 
        Set  oCursor= oWS.createCursor
        oCursor.gotoEndOfUsedArea(True)
        Lastline = oCursor.Rows.Count  
        If Nbexp = 0 Then Nbexp =1   ' au moins une ligne dans le fichier excel
         For i = 0 to Nbexp
             k = Lastline+i+1
           For j = 1 to UBound (XLtab, 1)
            XLtab (j, i) =  " " &  XLtab (j, i) &" "               
            oWS.getcellbyposition(j-1, k).SetString(XLtab (j, i) )
           Next
           set  oCell = oWS.getcellbyposition(14, k)
           call oCell.setPropertyValue ( "HoriJustify" ,HoriJustifyLEFT )
           If XLtab(21, i) = "  " Then           
            set oCell = oWS.getcellbyposition(20, k)
            oCell.SetFormula("= Q" &k+1 &"/P" &k+1)
            Set NFS = oSM.Bridge_GetStruct("com.sun.star.lang.Locale")
            NFS.Language = "fr"
            NFS.Country = "fr"
            NF = oWB.NumberFormats.queryKey("#,#0", NFS,True)
            If NF= -1 Then NF= oWB.NumberFormats.addNew("#,#0", NFS)        
            oCell.NumberFormat = NF         
           End If
         Next    
        oWS.Columns.OptimalWidth = True 
      End If     
      Test_Erreur "Xl 2"

 '-----------------------------------------------------------------------------------------------------------------------------------
 '---  Mise  jour fichier excel,
 ' 
      If XLflag = True Then
        Titre = " Enregistrement des rsultats"
        Msg = "Le fichier Excel : " &XLFile &vbcrlf &"est mis  jour"   &vbcrlf   &vbcrlf
        Msg = Msg &" Oui : pour conserver les rsultats" &vbcrlf &"Non : pour ignorer ce test"
        Boutons= vbYesNo + vbQuestion
        Reply = MsgBox (Msg, Boutons, Titre)
       If Reply = vbYes Then
           If XLtype =1 Then oWB.SaveAS XLfile 
           If XLtype =2 Then  oWB.storeAsURL XLurl, Sargs  
       End If
         If XLtype =1 Then    
            objExcel.ActiveWorkbook.Close
            objExcel.Application.Quit
            Set objExcel  = Nothing
            Set oWB = Nothing   
            Set oWS = Nothing 
            Test_Erreur "Close XL 1"
         End if
         If XLtype =2 Then       
            Call oDesk.activeFrame.Close(False)   
            Set oDesk = Nothing
            Set oSM = Nothing
            Test_Erreur "Close XL 2"
         End If 

      End If
  End If
 ' Fermeture et supression des fichiers intermdiaires
     Err.clear
     If Debug = 0 Then
      Projbak = Projet &"_bak" 
      If oFs.FileExists(Projbak) Then oFs.DeleteFile Projbak, True
      Dir = SrcPath & Projet_Src
      call Dir_Sup (Dir)                                     ' Suppresssion rpertoire sources
      Dir = Cache_Dir
      call Dir_Sup (Dir)                                     ' Suppresssion rpertoire caches BD
      Dir = CacheFiles_Dir
      call Dir_Sup (Dir)                                     ' Suppresssion rpertoire caches Files
      Dir = Prev_Dir
      call Dir_Sup (Dir)                                     ' Suppresssion rpertoire rendus
     End If
      strProcessKill = NotePad                               ' Arrt de NotePad
      call Kill_exe (strProcessKill ) 

      Test_Erreur "End script"
      oLog.close
      Set oLog = Nothing 
      Set oFolder = Nothing 
      Set oFs = Nothing
        
  WScript.Quit()
 
End If  ' fin de l'execution du script

 ' **************************************************************************************************************************
 ' --- Fin du programme principal
 ' **************************************************************************************************************************
 ' --------------------------------------------------------------------------------------------------------------------------
 ' Sous programme Cration de Directory
 ' --------------------------------------------------------------------------------------------------------------------------
Sub Dir_Create (Dir)
' Dim  oFs, oDir
' Dim aDir, sDir, iDir
' Err.Clear

 On Error Resume Next
 ' Set oFs = CreateObject("Scripting.FileSystemObject")

    DbgTxt = ("Rpertoire  : " &Dir) : Call DbgMsg (DbgTxt, 2)

    call Dir_Sup (Dir)   
    Call Dir_New (Dir)

    DbgTxt = ("Dir_Create  : " &Dir & " Err= " &Err.Number) : Call DbgMsg (DbgTxt, 2)
    Test_Erreur "Dir_Create"

  Debug = DbgSave
 ' Set oFs = Nothing
 ' Set oDir = Nothing

End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Fonction Cration de Directory (rcursive)
' --------------------------------------------------------------------------------------------------------------------------
Function Dir_New (DirectoryPath)
  Dim oFs
  Set oFs = CreateObject("Scripting.FileSystemObject")
  If oFs.FolderExists(DirectoryPath) Then Exit Function
  Call Dir_New (oFs.GetParentFolderName(DirectoryPath))
  oFs.CreateFolder(DirectoryPath)

End Function
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme Suppression  de Directory
' --------------------------------------------------------------------------------------------------------------------------
Sub Dir_Sup (Dir)
 Dim oFs

 Err.Clear
  On Error Resume Next
  DbgTxt =  ("Dir_suppress: " & Dir) : Call DbgMsg (DbgTxt, 2)
   Set oFs = CreateObject("Scripting.FileSystemObject")
    If oFs.FolderExists(Dir) Then 
      oFs.DeleteFolder Dir, force
      WScript.Sleep 200                   ' Wait until Explorer free the directory
    End If
   Test_Erreur "Dir_Sup"
  Debug = DbgSave
  Set oFs = Nothing

End Sub
' -------------------------------------------------------------------------------------------------------------------------
' Sous programme de cration du fichier Excel
' call XL_test  
' -------------------------------------------------------------------------------------------------------------------------			
Function XL_test

 Dim objExcel, oWB , oWS, oXL, oFs
 Dim oSM, oDesk, oUno                               ' OpenOffice / LibreOffice Service Manager /Desktop
 Dim oDoc, oDisp, args(), Array(1)
 Dim col
 On error resume next
 Redim args(0)
'~~> File Formats (ne fonctionne pas sur toutes les versions : pas utilis)
'51 = xlOpenXMLWorkbook (without macro's in 2007-2010, xlsx)
'52 = xlOpenXMLWorkbookMacroEnabled (with or without macro's in 2007-2010, xlsm)
'50 = xlExcel12 (Excel Binary Workbook in 2007-2010 with or without macro's, xlsb)
'56 = xlExcel8 (97-2003 format in Excel 2007-2010, xls)

 Set oFs = CreateObject("Scripting.FileSystemObject")
  
    XLflag = False
    XLtype = 0
    XLpath = Dirpath & Report_Proj
    XLfile = XLpath &  Report_File
 
    DbgTxt = (" Test Rep recap   : " & XLpath) : Call DbgMsg (DbgTxt, 2)
  If  Not oFs.FolderExists(XLPath)  Then 
    oXL =  oFs.CreateFolder(XLpath)
  Else 
    DbgTxt = ("Rep recap existant: " &XLpath ) : Call DbgMsg (DbgTxt, 2)             
  End If 
  If ForceOOo = 0 Then 
 '  Test de Cration d'un objet Excel
    Set objExcel = CreateObject("Excel.Application")  
  Else 
     Err.Number = 1  ' on force l'utilisation de OpenOffice
  End If
  If Err.number = 0 Then   
     XLtype= 1                             '   EXCEL est prsent sur la machine
     
     If Not oFS.FileExists (XLfile)  Then
      objExcel.Application.DisplayAlerts = False	
      objExcel.Application.Visible = False																												 
      Set oWB = objExcel.Workbooks.Add
      Set oWS =  oWB.WorkSheets(1)

      oWS.Activate
      oWS.Cells(1, 1).Value = "Nom"                 : oWS.Cells(2, 1).Value = "du"       : oWS.Cells(3, 1).Value = "test"
      oWS.Cells(1, 2).Value = "Date"
      oWS.Cells(1, 3).Value = "Fichiers temporaires" : oWS.Cells(2, 3).Value = "Fichier Log"
      oWS.Cells(1, 4).Value = "OS"
      oWS.Cells(1, 5).Value = "CPU model"           : oWS.Cells(2, 5).Value = "Mmoire RAM"
      oWS.Cells(1, 6).Value = "Graphics card"       : oWS.Cells(2, 6).Value = "Mmoire GPU"
      oWS.Cells(1, 7).Value = "Init"                : oWS.Cells(2, 7).Value = "Script"  : oWS.Cells(3, 7).Value = "(sec)" 
      oWS.Cells(1, 8).Value = "Sources"             : oWS.Cells(2, 8).Value = "Copie"   : oWS.Cells(3, 8).Value = "(sec)" 
      oWS.Cells(1, 9).Value = "Init"                : oWS.Cells(2, 9).Value = "Appli"   : oWS.Cells(3, 9).Value = "(sec)"
      oWS.Cells(1, 10).Value = "Cuda"
      oWS.Cells(1, 11).Value = "Uniform."           : oWS.Cells(2, 11).Value = "Audio"  : oWS.Cells(3, 11).Value = "(sec)"
      oWS.Cells(1, 12).Value = "Rendus"             : oWS.Cells(2, 12).Value = "(sec)"
      oWS.Cells(1, 13).Value = "GPU"                : oWS.Cells(2, 13).Value = "Load"   : oWS.Cells(3, 13).Value = "moy %"
      oWS.Cells(1, 14).Value = "GPU"                : oWS.Cells(2, 14).Value = "Load"   : oWS.Cells(3, 14).Value = "max %"
      oWS.Cells(1, 15).Value = " Fichiers exports"
      oWS.Cells(1, 16).Value = "Long"               : oWS.Cells(2, 16).Value = "Film"   : oWS.Cells(3, 16).Value = "(sec)"
      oWS.Cells(1, 17).Value = "Dure"              : oWS.Cells(2, 17).Value = "exp."   : oWS.Cells(3, 17).Value = "(sec)"
      oWS.Cells(1, 18).Value = "GPU"                : oWS.Cells(2, 18).Value = "Load"   : oWS.Cells(3, 18).Value = "moy %"
      oWS.Cells(1, 19).Value = "GPU"                : oWS.Cells(2, 19).Value = "Load"   : oWS.Cells(3, 19).Value = "max %"
      oWS.Cells(1, 20).Value = "Commentaires optionnels"
      oWS.Cells(1, 21).Value = "Ratio"              : oWS.Cells(2, 21).Value = "Temp"   : oWS.Cells(3, 21).Value = "rel"
      oWS.Columns.AutoFit()
      oWS.Columns("B").NumberFormat ="dd/mm/yyyy hh:mm:ss;@" 
      ows.Columns("U").NumberFormat = "#0.00"

      For Each col in oWS.Columns
        col.HorizontalAlignment = xlHAlignCenter
        col.VerticalAlignment   = xlVAlignCenter
      Next
      ows.Columns("O").HorizontalAlignment = xlHAlignLeft
      oWB.SaveAS XLfile 
      objExcel.ActiveWorkbook.Close
      objExcel.Application.Quit
      Test_erreur "Init XL 1"
      Set objExcel  = Nothing
      Set oWB = Nothing  
      Set oWS = Nothing
      DbgTxt = ("Fichier Excel cr: " & XLfile &" XLtype = " & XLtype) : Call DbgMsg (DbgTxt, 2)
     End If

  Else
      Err.Clear
      '  Test de Cration d'un service OpenOffice
      Set oSM = WScript.CreateObject("com.sun.star.ServiceManager")
   If Err.number = 0 Then
          XLtype= 2                        '   Open office  est prsent sur la machine
     If Not oFS.FileExists (XLfile)  Then

         Set oDesk = oSM.createInstance("com.sun.star.frame.Desktop")                         ' Create desktop 
         Set args(0) = oSM.Bridge_GetStruct("com.sun.star.beans.PropertyValue")               ' Creation structure d'arguments
         args(0).Name = "Hidden" : args(0).Value = True                                       ' Ouverture en mode cach
         Set oWB = oDesk.loadComponentFromURL("private:factory/scalc", "_blank", 0, args)     ' Cration d'un nouveau classeur 
         Set oWS = oWB.createInstance("com.sun.star.sheet.Spreadsheet")                       ' Cration d'une instance
         Set oWS = oWB.getSheets.getByIndex(0)                                                ' Slection de la premire feuille du classeur
	 
      oWS.getcellbyposition(0, 0).SetString("Nom")           : oWS.getcellbyposition(0, 1).SetString("du")      :oWS.getcellbyposition(0, 2).SetString("test")
      oWS.getcellbyposition(1, 0).SetString("Date")
      oWS.getcellbyposition(2, 0).SetString("Fichiers temporaires") : oWS.getcellbyposition(2, 1).SetString("Fichier Log")
      oWS.getcellbyposition(3, 0).SetString("OS")
      oWS.getcellbyposition(4, 0).SetString("CPU model")     : oWS.getcellbyposition(4, 1).SetString("Mmoire RAM") 
      oWS.getcellbyposition(5, 0).SetString("Graphics card") : oWS.getcellbyposition(5, 1).SetString("Mmoire GPU") 
      oWS.getcellbyposition(6, 0).SetString("Init")          : oWS.getcellbyposition(6, 1).SetString("script")  :oWS.getcellbyposition(6, 2).SetString("(sec)")
      oWS.getcellbyposition(7, 0).SetString("Sources")       : oWS.getcellbyposition(7, 1).SetString("Copie")   :oWS.getcellbyposition(7, 2).SetString("(sec)") 
      oWS.getcellbyposition(8, 0).SetString("Init")          : oWS.getcellbyposition(8, 1).SetString("Appli")   :oWS.getcellbyposition(8, 2).SetString("(sec)")
      oWS.getcellbyposition(9, 0).SetString("Cuda")
      oWS.getcellbyposition(10, 0).SetString("Uniform.")     : oWS.getcellbyposition(10, 1).SetString("Audio")  :oWS.getcellbyposition(10, 2).SetString("(sec)")
      oWS.getcellbyposition(11, 0).SetString("Rendus")	 : oWS.getcellbyposition(11, 1).SetString("(sec)")
      oWS.getcellbyposition(12, 0).SetString("GPU")          : oWS.getcellbyposition(12, 1).SetString("Load")   :oWS.getcellbyposition(12, 2).SetString("moy %") 
      oWS.getcellbyposition(13, 0).SetString("GPU")          : oWS.getcellbyposition(13, 1).SetString("Load")   :oWS.getcellbyposition(13, 2).SetString("max %")
      oWS.getcellbyposition(14, 0).SetString(" Fichiers exports") 
      oWS.getcellbyposition(15, 0).SetString("Long")         : oWS.getcellbyposition(15, 1).SetString("Film")   :oWS.getcellbyposition(15, 2).SetString("(sec)")
      oWS.getcellbyposition(16, 0).SetString("Dure")        : oWS.getcellbyposition(16, 1).SetString("exp.")   :oWS.getcellbyposition(16, 2).SetString("(sec)")
      oWS.getcellbyposition(17, 0).SetString("GPU")          : oWS.getcellbyposition(17, 1).SetString("Load")   :oWS.getcellbyposition(17, 2).SetString("moy %")
      oWS.getcellbyposition(18, 0).SetString("GPU")          : oWS.getcellbyposition(18, 1).SetString("Load")   :oWS.getcellbyposition(18, 2).SetString("max %")
      oWS.getcellbyposition(19, 0).SetString("Commentaires optionnels")
      oWS.getcellbyposition(20, 0).SetString("Ratio")        : oWS.getcellbyposition(20, 1).SetString("Temp")   :oWS.getcellbyposition(20, 2).SetString("rel")
 
      call   oWS.setPropertyValue ( "HoriJustify" ,HoriJustifyCENTER )
      call   oWS.setPropertyValue ( "VertJustify" ,VertJustifyCENTER )

      XLurl = ConvertToURL(XLfile)
      Set Sargs(0) = oSM.Bridge_GetStruct("com.sun.star.beans.PropertyValue")                  ' Creation structure d'arguments
      Sargs(0).Name = "FilterName" : Sargs(0).Value = "MS Excel 97"                            ' Sauvegarde au format Excel
      oWB.storeToURL XLurl, Sargs

    ' Suppression des objets pour librer la mmoire
      Set oDesk = Nothing
      Set oSM = Nothing
      DbgTxt = ("Fichier OOo cr  : " & XLfile &" XLtype = " & XLtype) : Call DbgMsg (DbgTxt, 2)   
     End If   
   End If
  End If

  If   oFs.FileExists(XLfile) And XLtype <> 0 Then 
        XLflag = True
        DbgTxt = ("Fichier XLS cumul : " & XLfile &vbcrlf &"XLtype = " & XLtype  &" XLflag = " &XLflag) : Call DbgMsg (DbgTxt, 2)  
        Test_Erreur "End XL"
  End If
     
End Function

' --------------------------------------------------------------------------------------------------------------------------
' Sous programme d'analyse de sous-dossiers
'       Call Scan_Dir (Path, FirstTime, DebTime, FinTime, Duree, AccesTime, FirstFile,  LastFile)
' --------------------------------------------------------------------------------------------------------------------------
Sub Scan_Dir (Path, FirstTime, DebTime, FinTime, Duree, AccesTime, FirstFile,  LastFile)

      Dim oDossier, oFs, NbFiles, NbReps, oSubDir, SubDir   
      Dim StartTime, EndTime
      Dim FirstName, LastName
      Dim LastAcces
      Set oDossier = nothing
      Set oFs = CreateObject("Scripting.FileSystemObject")  
      Set oDossier = oFs.GetFolder (Path)
      Duree = 0
      FinTime   =     DateValue( "01/01/2000") + TimeValue(" 00:00:01")  
      DebTime   =     DateValue( "31/12/2099") + TimeValue(" 23:59:59")
      AccesTime =     DateValue( "01/01/2000") + TimeValue(" 00:00:01")  
      LastFile = " "
      NbFiles = oDossier.Files.Count
      NbReps =  oDossier.SubFolders.Count
      DbgTxt =  "Rpertoire trait : "  & Path  &vbcrlf &" nb Fichiers/Rep  : "  & NbFiles &"/" & NBreps : Call DbgMsg (DbgTxt, 2)

    If NbReps  = 0 Then
            SubDir = Path
            If Right(SubDir,1) <> "\" Then SubDir = SubDir & "\"
            DbgTxt =  "  Sous-Rep trait : "  & SubDir  : Call DbgMsg (DbgTxt, 3)
            call Scan_Time (SubDir, FirstTime, StartTime, EndTime, FirstName, LastName, LastAcces) 
            DebTime = StartTime
            FinTime = EndTime
            firstFile = FirstName
            LastFile = LastName
            AccesTime = LastAcces
    Else
      For Each oSubDir in oDossier.SubFolders
            SubDir = oSubDir.path
            If Right(SubDir,1) <> "\" Then SubDir = SubDir & "\"
            DbgTxt =  "Sous-rep : "  & SubDir : Call DbgMsg (DbgTxt, 3)
            call Scan_Time (SubDir, FirstTime, StartTime, EndTime, FirstName, LastName, LastAcces)
          If LastName <> " " Then
            If StartTime < DebTime Then 
             DebTime = StartTime
             FirstFile = FirstName
            End If
            If EndTime   > FinTime  Then 
              FinTime = EndTime
              LastFile = LastName
            End If
            If LastAcces > AccesTime Then
               AccesTime = LastAcces
            End If
           End If
      Next          
    End If
    If LastFile <> " "  Then Duree = DateDiff ("s", DebTime, FinTime)
     DbgTxt =  "Retour Scan_Dir, Duree = " &Duree &" AccesTime = " & AccesTime : Call DbgMsg (DbgTxt, 2)
     Debug = DbgSave
  Set oFs = Nothing
  Set oDossier = Nothing
End sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme de Calcul de temps cration des fichiers et dernier accs
' call Scan_Time (SubDir, FirstTime, StartTime, EndTime, FirstName, LastName, LastAcces)
' --------------------------------------------------------------------------------------------------------------------------
Sub Scan_Time (SubDir, FirstTime, StartTime, EndTime, FirstFile, LastFile, LastAcces)

 Dim oFs, oFolder, oF
 Dim cTime, mTime, aTime
 Dim minTime, min_cTime, min_mTime, min_aTime
 Dim maxTime, max_cTime, max_mTime, max_aTime
 Dim maxName :   maxName = " "
 Dim minName :   minName = " "

 On Error Resume Next
  Set oFs = CreateObject("Scripting.FileSystemObject") 
  Set oFolder = oFs.GetFolder (SubDir) 
      Test_Erreur "Scan_Time"

    '  Calcul dure cumule de cration des fichiers  

 min_cTime =  DateValue( "31/12/2099") + TimeValue(" 23:59:59") 
 max_cTime =  DateValue( "01/01/2000") + TimeValue(" 00:00:01")
 min_mTime =  DateValue( "31/12/2099") + TimeValue(" 23:59:59")
 max_mTime =  DateValue( "01/01/2000") + TimeValue(" 00:00:01")
 min_aTime =  DateValue( "31/12/2099") + TimeValue(" 23:59:59")
 max_aTime =  DateValue( "01/01/2000") + TimeValue(" 00:00:01")
 minTime =    DateValue( "31/12/2099") + TimeValue(" 23:59:59")
 maxTime =    DateValue( "01/01/2000") + TimeValue(" 00:00:01")
    
          For Each oF In  oFolder.files
        ' for each file in the folder, get the last time it was created / modified /accessed
            
                If Test_Name (oF.Name, Files_Inc )      Then
                      cTime  = oF.DateCreated
                      mTime = oF.DateLastModified
                      aTime  = oF.DateLastAccessed
                      DbgTxt =  (oF.Name &" FirstTime = "  &FirstTime &"  cTime =  " & cTime &" mTime =  " &mtime &"  aTime = " &aTime)    : Call DbgMsg (DbgTxt, 5)
                  
'         On ne prend  en compte que les fichiers cres, modifis ou accds  aprs la date de rfrence.
                       If cTime > FirstTime Then  
                          DbgTxt =  (" cTime = " & cTime &" min_cTime = " & min_cTime &" max_cTime = " &max_cTime) : Call DbgMsg (DbgTxt, 5)
                           ' and save the minimum created time
                            If cTime < min_cTime Then 
                               min_cTime = cTime
                               If  min_cTime < minTime Then 
                                 minTime = min_cTime 
                                 minName = oF.name  
                               End If
                            End If
                              ' and save the maximum created time
                            If cTime >= max_cTime Then          
                                max_cTime = cTime
                                If  max_cTime > maxTime Then 
                                  maxTime = max_cTime
                                  maxName = oF.Name
                                End If
                            End If
                       End If
' Squence  supprimer si les fichiers caches sont mis  jour pendant l'export, ce qui fausse les rsultats
                       If mTime > FirstTime Then                   
                            DbgTxt =  (" mTime = " & mTime &" min_mTime = " & min_mTime &" max_mTime = " &max_mTime) : Call DbgMsg (DbgTxt, 5)
                          ' and save the minimum modified time
                            If mTime < min_mTime Then 
                                min_mTime = mTime 
                                If  min_mTime < minTime Then 
                                 minTime = min_mTime  
                                 minName = oF.name  
                              End If
                            End If
                          ' and save the maximum modified time
                            If mTime > max_mTime Then          
                               max_mTime = mTime
                               If  max_mTime > maxTime Then 
                                 maxTime = max_mTime
                                 maxName = oF.Name
                               End If
                            End If
                       End If

                       If aTime > FirstTime Then                   
                            DbgTxt =  (" aTime = " & aTime &" min_aTime = " & min_aTime &" max_aTime = " &max_aTime) : Call DbgMsg (DbgTxt, 5)
                          ' and save the minimum accessed time
                            If aTime < min_aTime Then 
                               min_aTime = aTime                             
                            End If
                           ' and save the maximum accessed time
                            If aTime > max_aTime Then          
                                max_aTime = aTime                            
                            End If
                       End If      
                End If 
          Next

                FirstFile = minName
                LastFile  = maxName
                StartTime = minTime
                EndTime   = maxTime
                LastAcces = max_aTime

  DbgTxt =          "FirstName  = " & minName    &vbcrlf
  DbgTxt = DbgTxt & "LastName   = " & maxName    &vbcrlf
  DbgTxt = DbgTxt & "FirstTime  = " & FirstTime  &vbcrlf
  DbgTxt = DbgTxt & "min_cTime  = " & min_cTime &"  max_cTime = " &max_cTime &vbcrlf
  DbgTxt = DbgTxt & "min_aTime  = " & min_aTime &"  max_aTime = " &max_aTime &vbcrlf
  DbgTxt = DbgTxt & "min_mTime  = " & min_mTime &"  max_mTime = " &max_mTime &vbcrlf
  DbgTxt = DbgTxt & "minTime    = " & minTime   &"  maxTime   = " &maxTime   &vbcrlf
  Call DbgMsg (DbgTxt, 4)
 
                If FirstFile =" " Then
                    StartTime = 0
                    EndTime = 0
                    LastAcces = 0
                End If
  Debug = DbgSave
  Set oFs = Nothing
  Set oFolder = Nothing
  Set oF = Nothing

End sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme de Calcul de temps cration des fichiers Exports
'  call File_Time (oF, FirstTime, DebTime, FinTime,  Duree, ModFlag,  LastFile)
' --------------------------------------------------------------------------------------------------------------------------
Sub  File_Time (oF, FirstTime, DebTime, FinTime, Duree, ModFlag,  LastFile)

 Dim cTime, mTime, aTime
 On error Resume Next

' On ne prend  en compte que les fichiers cres,  modifis ou accds  aprs la date de rfrence.
             Duree = 0
             LastFile = oF.Name
             IF Test_Name (Lastfile, Files_Inc)      Then
                   cTime =  oF.DateCreated
                   mTime =  oF.DateLastModified
                   aTime =  oF.DateLastAccessed
                   DbgTxt =  (oF.Name  &" cTime = " & cTime &" mTime =  " &mTime &" aTime = " &aTime &" FirstTime = "  &FirstTime) : Call DbgMsg (DbgTxt, 5)
                      If cTime > FirstTime Then 
                              DebTime = cTime
                              FinTime= mTime
                              Duree =DateDiff ("s", DebTime, FinTime)
                      Else 
	          ' Cas ou un fichier existant a t cras
  	                    If mTime > FirstTime Then                                    
                              DebTime = FirstTime
                              FinTime= mTime
                              Duree =DateDiff ("s", DebTime, FinTime)
                              ModFlag = "(*)"
                          End If  
                      End If                
             End If
  DbgTxt =  (oF.Name  &" cTime = " & cTime &" mTime = " &mtime &" aTime = " &aTime &" Dure = "  &Duree)    : Call DbgMsg (DbgTxt, 5)
  Debug = DbgSave
  Test_Erreur "File_Time"
End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme de Calcul charge GPU moyenne  partir de la log de GPU-Z
' --------------------------------------------------------------------------------------------------------------------------

Sub GpuZ_moy (Debut, Fin, Cmoy, CMax)
Dim oFs, Fich
Dim Tx, Tb, Tl, Ligne, i, j , k,  Jour, Heure, Datelog
 On Error Resume next
  Cmoy = 0
  Cmax = 0

  Set oFs = CreateObject("Scripting.FileSystemObject")  
  If oFs.FileExists(GpuZ_log) Then  
       set Fich = oFs.Getfile(GpuZ_log)  
       DbgTxt = ("Gpu-Z log : " &GpuZ_log &" Size = " &Fich.size &" "  & Debut &" " & Fin)  : Call DbgMsg (DbgTxt, 4)
       If Fich.size = 0 Then  Exit Sub                        ' carte graphique virtuelle : rien d'crit dans le fichier log
       set Fich=oFs.OpenTextFile(GpuZ_log,1,True)     
       Tx = Fich.ReadAll
       Fich.close 
       Tb = Split(Tx, vbLf, -1,0)
       Tl = Split(Tb(0), ",", -1,0)
      For i = 1 to (Ubound (Tl) -1)
       Ligne = Tl(i)
       DbgTxt =  ("i = " &i &" T= " &Ligne ) : Call DbgMsg (DbgTxt, 6)
        k =  Instr (1, Ligne ,"GPU Load", 0)                  ' on cherche la colonne GPU Load (variable suivant les versions)
        If k > 0 Then 
         j = i
         Exit For
       End If
      Next

      k = 0     
      For i = 1 to UBound (Tb) 
            Ligne = Tb(i)
            Tl  = Split(Ligne, ",", -1,0)
            Jour  = Datevalue (Tl(0))
            Heure = Timevalue (Tl(0))
            Datelog = CDate (Jour &" " & Heure)
            If Datelog >= Debut And Datelog < Fin Then   
              k = k+1
              If Tl(j) > Cmax Then Cmax = Tl(j)
               Cmoy = Cmoy + Tl(j)
               DbgTxt =  ("Dbut = " &Debut  & " Fin = "  &Fin  &" Temps = " & Datelog  &" Load = " & CLng(Cmoy/k)  &" " &Cmax )    
            End If
          If Datelog > Fin Then Exit For
      Next
      Cmoy  = Cmoy / k
  End If
  Debug = DbgSave    
  Set Fich = Nothing
  Set oFs = Nothing
  Test_Erreur "Gpu-Z_moy"
End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme de recuprations des infos d'un fichier
' --------------------------------------------------------------------------------------------------------------------------
Sub Info_File (P, F)

Dim objShell
Dim objFolder 
Dim strFileName 
Dim arrHeaders(34)
Dim T, Data, Header
 On Error Resume next
    Set objShell = CreateObject("Shell.Application")
    Set objFolder = objShell.NameSpace(P) 
    Set strFileName = objFolder.Items.Item(F) 
    Data = ""
    For T = 0 To 34
       arrHeaders(T) = objFolder.GetDetailsOf(objFolder.Items, T)
    Next
    For T = 0 To 34
        Data = (objFolder.GetDetailsOf(strFileName, T))
        Ftab(T) = Data
        Header = arrHeaders(T) 
        DbgTxt = CStr("T= " &T &" " & Header  & "= " & Data ) 
        Call DbgMsg (DbgTxt, 5) 
        If Err.Number = 5 Then Err.clear                      ' Bug VBS passage d'arguments
    Next
    Debug = DbgSave
    Set strFileName = Nothing
    Set objFolder = Nothing
    Set objShell = Nothing
    
 Test_Erreur "Info_File"

End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme de copie des Presets  
' call Presets_copy
' -------------------------------------------------------------------------------------------------------------------------	
Sub Presets_copy   

 On error Resume Next   
     
         If Not oFs.FolderExists(Presets_Dir)  Then
           Call Dir_Create (Presets_Dir) 
         End If
         If Right(Presets_Dir,1) <> "\" Then Presets_Dir = Presets_Dir & "\"
          From =  DirPath  &Presets  &Choix &"\" &Preset_File 
          Dest =   Presets_Dir  &Preset_File 
          DbgTxt = ("From = " & From &vbcrlf &"Dest = " &Dest) : Call DbgMsg (DbgTxt, 4)  
          If  oFS.FileExists (Dest) Then Exit Sub   
          oFs.Copyfile From, Dest, True
 Test_Erreur "preset_copy"
End Sub  
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme Lecture du fichier Projet ou Prfrences de Premiere et Edius
' --------------------------------------------------------------------------------------------------------------------------
Sub Read_Prefs (Fparm, Keyname, Value, Vlen, KeyEnd, index )

   Dim oFs, Fich, Tx, Tb , i, K1, K2
   Dim Key, Ks, Ke, Kl, Ve, Ligne
   On Error Resume Next
     Value = ""
     DbgTxt = (vbcrlf &"Fparm = " &Fparm &vbcrlf &" Key = " &Keyname &" " &KeyEnd ) : Call DbgMsg (DbgTxt, 4)
     set oFs=CreateObject("Scripting.FileSystemObject")
    If oFs.FileExists(Fparm) Then
       set Fich=oFs.OpenTextFile(Fparm,1,True)
       Tx = Fich.ReadAll
       Fich.close
       Tb = Split(Tx, vbLf, -1,0)
      If index > UBound (Tb) Then
         index = 0
         Value = ""
         Exit Sub
      End If
        K1 = Keyname
        K2 = KeyEnd
        If  K2 = "" Then K2 ="</" & Right (K1, Len(K1) -1)  
      For i = index to UBound (Tb) 
           Vlen =0       
           DbgTxt = ("i = " & i &" K1 = " &K1  & " K2 = " &K2)  : Call DbgMsg (DbgTxt, 6)
           Ligne = Tb(i)
           Ks = InStr (1, Ligne, "<", 1)
           Ke = InStr (1, Ligne, ">", 1)         
           If ke> 0 then            
              Kl =  Ke-Ks
              Key = Mid (Ligne, Ks,  Kl +1) 
              Ve = InStr (Ke, Ligne, "<", 1)
              Vlen = Ve-Ke-1
              DbgTxt =  ( i &" " &key  &" " & Vlen ) : Call DbgMsg (DbgTxt, 6)
             If Key = K1 Then 
                   index =i +1
                   If Vlen > 0 Then   Value = Mid (Ligne, Ke+1, Vlen) 
                   DbgTxt =  ("K1= " &K1   &" = " &Value &" Vlen = " &Vlen &" Pos = " &i ) : Call DbgMsg (DbgTxt, 6)
                  Exit For
             End If     
             If Key = K2 Then
                   DbgTxt =  ("K2= " &K2   &" = " &Value &" Vlen = " &Vlen &" Pos = " &i ) : Call DbgMsg (DbgTxt, 6)
                   index = 0
                   Value = ""
                  Exit For
             End If 
           End If
      Next
    Else 
      DbgTxt =  ("Fichier paramtres non trouv" ) : Call DbgMsg (DbgTxt, 4)   
    End If
      DbgTxt = (" key = " &Keyname &" = "  &Value &" L = " & Vlen &vbcrlf) : Call DbgMsg (DbgTxt, 4)
     Test_Erreur "Read_Prefs"
     Debug = DbgSave
     Set oFs = Nothing
     Set Fich = Nothing
End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Sous programme Update  Prfrences de Premiere et Edius
' call Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)
' --------------------------------------------------------------------------------------------------------------------------
Sub Updt_Prefs  (Fparm, Keyname, Value, Vpos, Nval)

   Dim oFs, Fich, Fsave, Fsize, Ligne, Tx, Tb , i, Ub
   Dim Key,  Ks, Ke, Kl, Ve

   On Error Resume Next
     Value = ""
     DbgTxt = (vbcrlf &Fparm &" "  &Keyname &" "  &vbcrlf) : Call DbgMsg (DbgTxt, 4)
     set oFs=CreateObject("Scripting.FileSystemObject")
     Fsave = Fparm &"_bak"
    If oFs.FileExists(Fparm) Then
       If Not oFs.FileExists(Fsave) Then
        oFs.CopyFile Fparm, Fsave, True             ' on cre une version de backup du fichier modifi
       End If
        set Fich = oFs.Getfile(Fparm)
        Fsize = Fich.Size
       If Fsize = 0 Then     
        oFs.DeleteFile Fparm, True
        oFs.CopyFile Fsave, Fparm, True
       End If
        set Fich=oFs.OpenTextFile(Fparm,1,True)     ' ouverture en lecture
        Tx = Fich.ReadAll
        Fich.close
        set Fich=oFs.OpenTextFile(Fparm,2,True)     ' ouverture en ecriture      
        Tb = Split(Tx, vbLf, -1,0)
        Ub = UBound (Tb) 
      For i = 0 to Ub
            Vlen =0
            Ligne = Tb(i)
            Ks = InStr (1, Ligne, "<", 1)
            Ke = InStr (1, Ligne, ">", 1)
           If ke> 0 then            
             Kl =  Ke-Ks
             Key = Mid (Ligne, Ks,  Kl +1)         
             DbgTxt =  (  i &" " &key ) : Call DbgMsg (DbgTxt, 6)
             If Key = Keyname Then 
                Value = LTrim ( Tb(i+Vpos) )
                DbgTxt =  (Keyname &vbcrlf &"Parametre origine Ligne " & (Vpos +i) &" Val = " & Value)  : Call DbgMsg (DbgTxt, 6)
 '                Modification de la valeur                 
                  Tb(i+Vpos) = Nval
                DbgTxt =  ("Parametre modifi ligne " & (Vpos +i)   &" Nval=" & Nval )  : Call DbgMsg (DbgTxt, 6)
             End If
           End If
       Ligne = Tb(i) & vblf
       Vlen = Len(Ligne)
 '      Fich.writeline  Ligne
       Fich.write Ligne
      Next
      Fich.close
    Else 
      DbgTxt =  ("Fichier paramtres non trouv") : Call DbgMsg (DbgTxt, 4)
    End If
     Test_Erreur "Updt_Prefs"
     Debug = DbgSave    
     Set Fich = Nothing
     Set oFs = Nothing
End Sub
' --------------------------------------------------------------------------------------------------------------------------
'Sous programme identification de la configuration
' --------------------------------------------------------------------------------------------------------------------------
Sub Conf_Type 

 Dim dtmConvertedDate, dtmInstallDate
 Dim strComputer
 Dim objWMIService
 Dim colOperatingSystems
 Dim objOperatingSystem
 Dim colItems
 Dim objItem
 Const wbemFlagReturnImmediately = &h10
 Const wbemFlagForwardOnly = &h20
 On error Resume Next

 strComputer = "."

 Set dtmConvertedDate = CreateObject("WbemScripting.SWbemDateTime")
 Set objWMIService = GetObject("winmgmts:"  & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")

 ' Query system properties
 Set colOperatingSystems = objWMIService.ExecQuery  ("Select * from Win32_OperatingSystem")
 For Each objOperatingSystem in colOperatingSystems
      OsName = objOperatingSystem.Caption
     If InStr (1,OsName, "XP", 0)       Then System = "XP"
     If InStr (1,OsName, "Vista", 0)    Then System = "Vista"
     If InStr (1,OsName, "7", 0)        Then System = "W7"
     If InStr (1,OsName, "8", 0)        Then System = "W8"
    DbgTxt = "Boot Device: " & objOperatingSystem.BootDevice
    DbgTxt = DbgTxt &vbcrlf & "Build Number: " & objOperatingSystem.BuildNumber
    DbgTxt = DbgTxt &vbcrlf & "Build Type: " & objOperatingSystem.BuildType
    DbgTxt = DbgTxt &vbcrlf & "Caption: " & objOperatingSystem.Caption &" OS = " & OsName
    DbgTxt = DbgTxt &vbcrlf & "Code Set: " & objOperatingSystem.CodeSet
    DbgTxt = DbgTxt &vbcrlf & "Country Code: " & objOperatingSystem.CountryCode
    DbgTxt = DbgTxt &vbcrlf & "Debug: " & objOperatingSystem.Debug
    DbgTxt = DbgTxt &vbcrlf & "Encryption Level: " & objOperatingSystem.EncryptionLevel
    dtmConvertedDate.Value = objOperatingSystem.InstallDate
    dtmInstallDate = dtmConvertedDate.GetVarDate
    DbgTxt = DbgTxt &vbcrlf & "Install Date: " & dtmInstallDate 
    DbgTxt = DbgTxt &vbcrlf & "Licensed Users: " & objOperatingSystem.NumberOfLicensedUsers
    DbgTxt = DbgTxt &vbcrlf & "Organization: " & objOperatingSystem.Organization
    DbgTxt = DbgTxt &vbcrlf & "OS Language: " & objOperatingSystem.OSLanguage
    DbgTxt = DbgTxt &vbcrlf & "OS Product Suite: " & objOperatingSystem.OSProductSuite
    DbgTxt = DbgTxt &vbcrlf & "OS Type: " & objOperatingSystem.OSType
    DbgTxt = DbgTxt &vbcrlf & "Primary: " & objOperatingSystem.Primary
    DbgTxt = DbgTxt &vbcrlf & "Registered User: " & objOperatingSystem.RegisteredUser
    DbgTxt = DbgTxt &vbcrlf & "Serial Number: " & objOperatingSystem.SerialNumber
    DbgTxt = DbgTxt &vbcrlf & "Version: " & objOperatingSystem.Version
 Next
   
 Set WshShell = CreateObject("WScript.Shell") 
        OsType = WshShell.RegRead("HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment\PROCESSOR_ARCHITECTURE")
                If OsType = "x86" then
                   OsType = "32"
                  DbgTxt = DbgTxt &vbcrlf &  "mode =  " & "Windows 32bits system detected"
                elseif OsType = "AMD64" then
                   OsType = "64"
                   DbgTxt = DbgTxt &vbcrlf & "mode =  " & "Windows 64bits system detected"
                end if	

  ' Query processor properties
 Set colItems = objWMIService.ExecQuery ("SELECT * FROM Win32_Processor", "WQL",  wbemFlagReturnImmediately + wbemFlagForwardOnly)              
 For Each objItem In colItems	
                Cpu = objItem.Name
                Cpu_F= objItem.CurrentClockSpeed
                Cpu_Fm= objItem.MaxClockSpeed
                DbgTxt = DbgTxt &vbcrlf &"ID : " & objItem.DeviceID  & vbcrlf  &"CPU Type  : " &Cpu &"  " &Cpu_F &" /" &Cpu_Fm &vbCrLf 
 Next  
                i = Instr(1, Cpu, "Processor", 1)
                If i > 1 Then
                 Cpu = Mid(Cpu, 1, i-1)
                End If
 Test_erreur "Cpu"

 ' Query memory properties
 Set colItems = objWMIService.ExecQuery ("SELECT * FROM Win32_Computersystem")               
 For Each objItem In colItems	
                Msize  = Round ((objItem.TotalPhysicalMemory + 3000000) /1024/1024) 
 Next  
  Set colItems = objWMIService.ExecQuery ("SELECT * FROM Win32_PhysicalMemory")
                If Err Then Test_erreur
 For Each objItem In colItems	
                Mfreq  = objItem.Speed
 Next  
                DbgTxt =   DbgTxt  &   "Memory Size : " & Msize   & "   " &  Mfreq  &vbcrlf 
                Test_erreur "Mem"

 ' Query Video card properties
 Set colItems = objWMIService.ExecQuery ("SELECT * FROM Win32_VideoController")

 For Each objItem In colItems	
                Vcard = objItem.Description
                Vproc = objItem.VideoProcessor
                Vmem  = objItem.AdapterRAM
    If Vmem > 0  Then
                 Vmem = Round (Vmem /1024/1024)
    Else 
                 Vmem = "?"
    End If
 Next  
		 DbgTxt =   DbgTxt  &   "Video card : " & Vcard  & " /" & Vmem &" Mb" &vbcrlf : Call DbgMsg (DbgTxt, 5)
 Test_erreur "Vcard"

' Display results
               
 Debug = DbgSave

End Sub
'---------------------------------------------------------------------------------------------------------------------------
' Sous programme de caractrisation des disques 
' --------------------------------------------------------------------------------------------------------------------------
Sub Disk_Type (File, Mode)
Dim oFs, Fich
Dim objWMIService, colDiskDrives, objDrive, strDeviceID, strComputer
Dim colPartitions, objPartition, colLogicalDisks, objLogicalDisk
Dim Ret, i, k, Tx, Tb, Lettre, Ligne, Parm, Value
Dim D_Letter, D_Number, D_type, P_Number

 On error Resume Next
set oFs=CreateObject("Scripting.FileSystemObject")
    Lettre = ""
    k = Instr(1, File ,":\", 0) -1
    If k <> 0 Then Lettre =  Mid(File, k, 2)

strComputer = "."
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
Set colDiskDrives = objWMIService.ExecQuery("SELECT * FROM Win32_DiskDrive")
 
  For Each objDrive In colDiskDrives
    DbgTxt = ("Physical Disk: " & objDrive.Caption & " -- " & objDrive.DeviceID  ) : Call DbgMsg (DbgTxt, 4)
    strDeviceID = Replace(objDrive.DeviceID, "\", "\\")
    Set colPartitions = objWMIService.ExecQuery _
        ("ASSOCIATORS OF {Win32_DiskDrive.DeviceID=""" & _
            strDeviceID & """} WHERE AssocClass = " & _
                "Win32_DiskDriveToDiskPartition")
 
    For Each objPartition In colPartitions
        DbgTxt = ("Disk Partition: " & objPartition.DeviceID ) : Call DbgMsg (DbgTxt, 6)
        Set colLogicalDisks = objWMIService.ExecQuery _
            ("ASSOCIATORS OF {Win32_DiskPartition.DeviceID=""" & _
                objPartition.DeviceID & """} WHERE AssocClass = " & _
                    "Win32_LogicalDiskToPartition")
 
        For Each objLogicalDisk In colLogicalDisks
            D_Letter = objLogicalDisk.DeviceID
            DbgTxt = ("Logical Disk: " & D_Letter) : Call DbgMsg (DbgTxt, 6)

            If D_Letter = Lettre Then
             D_type   = objDrive.InterfaceType
             D_Number = objPartition.DiskIndex
             P_Number = objPartition.Index
             SmartCtl_dir = DirPath &Src_Test &"Pgm\" 
             SmartCtl_log = Ftemp & "SmartCtl.txt"
             SmartCtl_prog = SmartCtl_dir & "smartctl.exe"
             SmartCtl_cmd = "-i  " &Lettre &"  > " & SmartCtl_log
             Prog_run = SmartCtl_prog  &" "  &SmartCtl_cmd 
             DbgTxt = (" SmartCtl   = " &Prog_run) : Call DbgMsg (DbgTxt, 4)
             Ret  = WshShell.Run  ( "CMD /k " &Prog_run, 2 ,False)
             WScript.Sleep 200                                        ' Attente ecriture fichier log

             If oFs.FileExists(SmartCtl_log) Then
               set Fich = oFs.OpenTextFile(SmartCtl_log,1,True)
               Tx = Fich.ReadAll
               Fich.close
               Tb = Split(Tx, vbcrlf, -1,0)
               For i = 0 to UBound (Tb)
                 Ligne = Tb(i)                                        'contient vbcrlf
                 k = Instr(1, Ligne ,":", 0) -1
                 Parm =  Trim (Left(Ligne, k))
                 Value = Trim (Right(Ligne, Len(Ligne)-k-4))            
                 DbgTxt = ("i = " & i &"Parm =" &Parm &" V=" &Value &" L=" &Len(Value))  : Call DbgMsg (DbgTxt, 4)
                 Select Case Parm
                 Case "Rotation Rate" 
                  If Value  = "Solid State Device" Then D_type = "SSD"
                 Case "ATA Version is"
                  If D_type <> "SSD" Then D_type ="IDE"
                 Case "SATA Version is"
                  If D_type <> "SSD" Then
                   D_type ="Sata2"
                   k = Instr(1, Value, "(current: 6.0 Gb/s)", 0) -1
                   if k > 0 Then D_type = "Sata3"
                  End If
                 End Select
               Next
             End If
             Exit For
            End If 

        Next
    Next
  Next
    If Lettre <> "" Then Mode = Lettre & D_type &"-D" &D_Number &"P" &P_Number
    DbgTxt =  Mode : Call DbgMsg (DbgTxt, 4)
    Call Kill_exe ("cmd.exe")
    If oFs.FileExists(SmartCtl_log) Then oFs.DeleteFile SmartCtl_log, True
 Test_erreur "Disk_Type"
 Debug = DbgSave
End Sub
'---------------------------------------------------------------------------------------------------------------------------
' Fonction d'arret des taches annexes
' --------------------------------------------------------------------------------------------------------------------------
Sub Kill_exe (strProcessKill)

 Dim objWMIService, objProcess, colProcess
 Dim strComputer, Process_list
 Dim Process
 On error Resume Next
  DbgTxt = ("Arret de l'application : " & strProcessKill) : Call DbgMsg (DbgTxt, 4)
  strComputer = "."
   Process_list =  "Select * from Win32_Process "   ' Where Name = " & strProcessKill  
  Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2") 
  Set colProcess = objWMIService.ExecQuery (Process_list)
  For Each objProcess in colProcess
   Process = objProcess.Name
   DbgTxt =("Prog = " &strProcessKill &" Process = " &Process ) : Call DbgMsg (DbgTxt, 6)
   If Process = strProcessKill Then 
    objProcess.Terminate()   
   End If
  Next 
  
  Test_Erreur "Kill"
End Sub
'---------------------------------------------------------------------------------------------------------------------------
' Fonction de test des suffixes de fichiers  (fichiers  pris en compte en caches, preview et  export)
' --------------------------------------------------------------------------------------------------------------------------
Function Test_Name (nom_fic, F_Inc()  )

 Dim j,  k , Ub, filesuffix
 On Error Resume Next
        Test_Name = False
        Ub = UBound(F_Inc)
        j=  InStrRev (nom_fic ,".", -1, 1)
        filesuffix = Mid (nom_fic, j+1,  3)
      For k = 0 to Ub  
        DbgTxt =  "Fichier trait : "  & nom_fic  &" suffix = " &filesuffix  &" Test = " &F_Inc (k)  : Call DbgMsg (DbgTxt, 6)       
       If  filesuffix = F_Inc (k) Then 
               Test_Name = True
	       DbgTxt =  "Fichier Inclu  : "  & nom_fic   : Call DbgMsg (DbgTxt, 5)
	       Exit For
       End If
      Next
          DbgTxt =  "Fichier trait : "  & nom_fic  &" suffix = " &filesuffix  &" Ret = " &Test_Name  : Call DbgMsg (DbgTxt, 5)
 Test_Erreur "Test_Name"
 Debug = DbgSave
End Function
' --------------------------------------------------------------------------------------------------------------------------
'- Fonction Message de debug
' --------------------------------------------------------------------------------------------------------------------------
Sub DbgMsg (Txt, Ndbg) 

  Dim Dbg
  On Error Resume Next
	          Dbg = Abs (Debug)
              If Dbg =   0 Then Exit Sub
                    Titre = " OK : suite dbug , Annuler : sort du mode dbug pour la fonction en cours"
                    Boutons= vbOKCancel + vbInformation
                If Dbg >= 1   And Dbg <10 Then 
                   If Dbg   >= Ndbg       Then
                      Reply = MsgBox (Txt, Boutons, Titre)
                      If Reply = vbCancel Then                     
                        Debug = 0
                      End If
                   End If
                End If  
                If Dbg >= 11 And Dbg <20 Then
                   If  (Dbg - 10)  >= Ndbg       Then
                      oLog.WriteLine Txt                  
                      Reply = MsgBox (Txt, Boutons, Titre)
                      If Reply = vbCancel Then
                        Debug = 0                 
                      End If
                   End If
                End If    
                If Dbg >= 21 And Dbg <30 Then
                   If  (Dbg - 20)  >= Ndbg       Then
                      oLog.WriteLine Txt                  
                   End If
                End If 
   If Err.Number = 5 Then Err.clear                         'Bug de VBScript sur le passage d'arguments
End Sub
' --------------------------------------------------------------------------------------------------------------------------
' Fonction conversion nom fichier / adresse URL
' --------------------------------------------------------------------------------------------------------------------------
Function ConvertToURL(sFileName)

 Dim sTmp
 If Left(sFileName, 7) = "file://" Then
   ConvertToURL = sFileName
   Exit Function
 End If

 ConvertToURL = "file:///"
 sTmp = oFs.GetAbsolutePathName(sFileName)
' replace any "\" by "/"
   sTmp = Replace(sTmp,"\","/") 
' replace any "%" by "%25"
   sTmp = Replace(sTmp,"%","%25") 
' replace any " " by "%20"
   sTmp = Replace(sTmp," ","%20")
 ConvertToURL = ConvertToURL & sTmp
End Function
' --------------------------------------------------------------------------------------------------------------------------
' Fonction Message d'erreur bloquante
' --------------------------------------------------------------------------------------------------------------------------
Function Test_Erreur (F)
              If Err.Number <> 0 Then
                DbgTxt = (F &" Err = " & Err.Number &" " &Err.Description &vbcrlf  &" Erreur non traite :  Relancez le script" ) 
                oLog.WriteLine DbgTxt
                oLog.close
                Titre = F
                Boutons= vbcritical
                Msg =  (" Err = " &  Err.Number &"  " &Err.Description &vbcrlf &vbcrlf &" Erreur non traite :  Relancez le script" &vbcrlf )       
                Rep = MsgBox (Msg, Boutons, Titre)

                Set oLog = Nothing 
                Set oFs  = Nothing
                Set oFolder = Nothing
                WScript.Quit()
              End If
End Function